#include 'AP5MAIL.CH'
#include 'TBICODE.CH'
#INCLUDE "PROTHEUS.CH"
#INCLUDE "TBICONN.CH"  
#INCLUDE "COLORS.CH"

Static aStackTMP

/*/

Ŀ
Funo     GIVIA000  Autor  Gerardo Martinez       Data  26.07.07  
Ĵ
Sintaxe    GIVIA000()                                                  
           Rotina de inclusao de Pedido/orcamento dos representantes.     
Ĵ
ParametrosNenhum                                                       
Ĵ
Retorno                                                                
Ĵ
Descrio Esta rotina permite as operacoes de pesquisa, visualizacao,  
          inclusao, alteracao, exclusao, copia, cancelamento de um or- 
          camento de venda.                                            
          Nesta rotina serao tratados todos os tipos de filtros para   
          os representantes, assim sendo:                              
           - Visualizacao somente de seus orcamentos.                  
           - Visualizacao somente de seus clientes.                    
           - Condicao de Pagamento pre-fixada sem possibilidade de al- 
             teracao.                                                  
           - Tabela de preco pre-fixada.                               
           - Tipo de Frete Pre-determinado.                            
           - Consulta ao estoque indisponivel.                         
           - Tipo de Saida(TES) pre-determinada.                       
                                                                       
           PARA O REPRESENTANTE APARECE COMO PEDIDO DE VENDA!!!!       
Ĵ
Uso        GIVI DO BRASIL LTDA.                                        
ٱ


/*/
//Ŀ
// Define Array contendo as Rotinas a ]utar do programa         
// ----------- Elementos contidos por dimensao ------------     
// 1. Nome a aparecer no cabecalho                              
// 2. Nome da Rotina associada                                  
// 3. Usado pela rotina                                         
// 4. Tipo de Transao a ser efetuada                          
//    1 - Pesquisa e Posiciona em um Banco de Dados             
//    2 - Simplesmente Mostra os Campos                         
//    3 - Inclui registros no Bancos de Dados                   
//    4 - Altera o registro corrente                            
//    5 - Remove o registro corrente do Banco de Dados          
//
User Function GIVIA000(xAutoCab,xAutoItens,nOpcAuto,lSimulacao)

//Ŀ
//Declaracao das variaveis                                      
//
Local aCores := {	{ 'SCJ->CJ_STATUS=="A"' , 'ENABLE'		},;	
					{ 'SCJ->CJ_STATUS=="B"' , 'DISABLE'		},;	
					{ 'SCJ->CJ_STATUS=="C"' , 'BR_PRETO'	},;	
					{ 'SCJ->CJ_STATUS=="D"' , 'BR_AZUL'		},;
					{ 'SCJ->CJ_STATUS=="E"' , 'BR_AMARELO'	}}  

DEFAULT lSimulacao  := .F.

Private lOnUpdate   := .T.
Private cCadastro	:= OemtoAnsi("Pedidos de Vendas - Representantes")
Private l415Auto 	:= ( Valtype(xAutoCab) == "A"  .and. ValType(xAutoItens) == "A" )
Private aAutoCab	:= {}
Private aAutoItens	:= {}
Private aRotina		:= {{"Pesquisar"	,"AxPesqui"		, 0 , 1 },;
						{"Visualizar"	,"U_A000Visual"	, 0 , 2 },;
						{"Incluir"		,"U_A000Inclui"	, 0 , 3 },;
						{"Alterar"		,"U_A000Altera"	, 0 , 4 },;
						{"Exclui"		,"U_A000Exclui"	, 0 , 5 },;
						{"Cancelar"		,"U_A000Cancel"	, 0 , 4 },;
						{"Liberar"		,"U_A000libera"	, 0 , 2 },;
						{"impRimir"		,"U_A000Impr"	, 0 , 2 },;
						{"cOpiar"		,"U_A000Copia"	, 0 , 3 },;
						{"leGenda"		,"U_A000Legend"	, 0 , 2 }}

aIndexSCJ	:=	{}

dbSelectArea("SCJ")
dbSetOrder(1)
MsSeek(xFilial())
If ( AMIIn(5) )
	//Ŀ
	//Aqui deve entrar o filtro de visualizacao de pedidos                     
	// Verificar no cadastro do cliente onde esta a amarracao, para            
	// filtrar os clientes / pedidos a serem exibidos na tela.                 
	//                                                                         
	//

	cFilSCJ := "CJ_FILIAL =='"+xFilial("SCJ")+"' "
	cQrySCJ := "SCJ.CJ_FILIAL='"+xFilial("SCJ")+"'"

IF __CUSERID $ GETMV("MV_CIRC001")

		cFilSCJ += ".And. CJ_E_USER == '"+__CUSERID+"'"
	//	cFilSCJ += ".And. CJ_BLWMS == '03'"
	//	cFilSCJ += ".And. EMPTY(CJ_NFISCAL) "
	//	cFilSCJ += ".And. CJ_STSERV == '1' "	
	//	cFilSCJ += ".And. C9_PEDIDO >= '"+MV_PAR01+"' .And. C9_PEDIDO <= '"+MV_PAR02+"'"
	//	cFilSCJ += ".And. DTOS(C9_DATALIB) == '"+DTOS(MV_PAR03)+"'"
	
		cQrySCJ	+= " AND SCJ.CJ_E_USER == '"+__CUSERID+"'"
	//	cQrySCJ += " AND SC9.C9_BLWMS = '03'"
	//	cQrySCJ += " AND SC9.C9_NFISCAL = ''"
	//	cQrySCJ += " AND SC9.C9_STSERV = '1'"                
	//	cQrySCJ += " AND SC9.C9_PEDIDO BETWEEN '"+MV_PAR01+"' AND '"+MV_PAR02+"'"
	//	cQrySCJ += " AND SC9.C9_DATALIB = '"+DTOS(MV_PAR03)+"'"

ENDIF
	
	//Ŀ
	//Realiza a Filtragem para listar somente o q ainda nao foi separado.     
	//

	bFiltraBrw := {|x| If(x==Nil,FilBrowse("SCJ",@aIndexSCJ,@cFilSCJ),{cFilSCJ,cQrySCJ,"","",aIndexSCJ}) }
	Eval(bFiltraBrw)
	SCJ->(MsSeek(xFilial()))

	mBrowse( 6, 1,22,75,"SCJ",,,,,,aCores)
EndIf
Return(.T.)

/*/


Ŀ
Funo    A000Inclui Autor                         Data           
Ĵ
Descrio  Programa de Inclusao de Orcamentos de Venda                
Ĵ
Sintaxe e  Void A000Inclui(ExpC1,ExpN1,ExpN2,ExpX1,[ExpC2])           
Ĵ
Parametros ExpC1 = Alias do arquivo                                   
           ExpN2 = Numero do registro                                 
           ExpN3 = Opcao selecionada                                  
           ExpX4 = Sem funcao                                         
           ExpC5 = Numero do orcamento incluido ( passado por refe-   
           rencia                                                     
           ExpC6 = Codigo do cliente                                  
           ExpC7 = Loja do Cliente                                    
Ĵ
 Uso       GIVIA000                                                   
ٱ


/*/
User Function A000Inclui(cAlias,nReg,nOpcx,xPar,cNumOrc,cCodCli,cLoja)

Local aArea		:= GetArea("SCJ")
Local nStack    := GetSX8Len() 
Local nX 		:= 0
Local nOpcA		:= 0
Local cArqSCL	:= ""
Local cArqSCK	:= ""
Local cNumAnt   := "" 
Local oDlg
Local oSay
Local oGetDB
Local aPosObj   := {}
Local aObjects  := {}
Local aSize     := {}
Local aPosGet   := {}
Local aInfo     := {}
Local nGetLin   := 0
Local cLojaE    := "01"

Private aTela[0][0]
Private aGets[0]
Private bCampo		:= { |nField| Field(nField) }
Private aHeader		:= {}
Private aHeaderSCL	:= {}
Private aHeaderSCK	:= {}

l415Auto := If(Type("l415Auto")<>"U",l415Auto,.F.)
l416Auto := If(Type("l416Auto")<>"U",l416Auto,.F.)

DEFAULT cNumOrc := ""
DEFAULT cCodCli := ""
DEFAULT cLoja   := ""     

//Ŀ
// Inicializa as Variaveis da Enchoice                          
//
dbSelectArea("SCJ")
For nX:= 1 To FCount()
	M->&(EVAL(bCampo,nX)) := CriaVar(FieldName(nX),.T.)
Next nX
If !Empty(cCodCli)
	M->CJ_CLIENTE := cCodCli
	M->CJ_CLIENT  := cCodCli	
	M->CJ_LOJA    := cLoja
	M->CJ_LOJAENT := cLojaE
EndIf
//Ŀ
// Monta aHeader                                                
//
A000Monta(@cArqSCK,@cArqSCL,.T.)
aHeader := aHeaderSCK
//Ŀ
// Atualiza o aHeader para a Rotina Automatica                  
//

//Ŀ
// Desabilita a Tecla F4                                        
//
SetKey(VK_F4,Nil)

dbSelectArea("TMP1")
//Ŀ
// Montagem da Tela                                             
//

//Ŀ
// Faz o calculo automatico de dimensoes de objetos     
//
aSize := MsAdvSize()

aObjects := {}
AAdd( aObjects, { 100, 100, .t., .t. } )
AAdd( aObjects, { 100, 100, .t., .t. } )
AAdd( aObjects, { 100, 015, .t., .f. } )

aInfo := { aSize[ 1 ], aSize[ 2 ], aSize[ 3 ], aSize[ 4 ], 3, 3 }
aPosObj := MsObjSize( aInfo, aObjects )

aPosGet := MsObjGetPos(aSize[3]-aSize[1],315,;
	{{005,070,110,175,215,280}} )
nGetLin := aPosObj[3,1]

DEFINE MSDIALOG oDlg TITLE OemtoAnsi("Pedidos de Venda - Representante") From aSize[7],0 to aSize[6],aSize[5] of oMainWnd PIXEL
EnChoice( "SCJ" ,nReg,nOpcx,,,,,aPosObj[1],,3,,,"U_A000VldTOk",,,.F.)
oGetDb := MsGetDB():New(aPosObj[2,1],aPosObj[2,2],aPosObj[2,3],aPosObj[2,4],nOpcx,"U_A000LinOk","U_A000TudOk","+CK_ITEM",.T., , ,.T., ,"TMP1")
Private oGetDad := oGetDb
@ nGetLin,aPosGet[1,1] SAY oSay PROMPT OemToAnsi("Total do Pedido") 	SIZE 060,009 PIXEL OF oDlg
@ nGetLin,aPosGet[1,3] SAY oSay PROMPT OemToAnsi("Descontos") 			SIZE 060,009 PIXEL OF oDlg
@ nGetLin,aPosGet[1,5] SAY oSay PROMPT OemToAnsi("=")					SIZE 060,009 PIXEL OF oDlg 
@ nGetLin,aPosGet[1,2] SAY oSay PROMPT 0    							SIZE 040,009 PICTURE PesqPict("SCK","CK_VALOR",16) PIXEL OF oDlg
oSay:Cargo := "Valor"
@ nGetLin,aPosGet[1,4] SAY oSay PROMPT 0    							SIZE 040,009 PICTURE PesqPict("SCK","CK_VALOR",14) PIXEL OF oDlg
oSay:Cargo := "Desconto"
@ nGetLin,aPosGet[1,6] SAY oSay PROMPT 0								SIZE 040,009 PICTURE PesqPict("SCK","CK_VALOR",16) PIXEL OF oDlg
oSay:Cargo := "Total"
ACTIVATE MSDIALOG oDlg ON INIT Ma000Bar(oDlg,{||nOpcA:=1,IIf(oGetDb:TudoOk().And.Obrigatorio(aGets,aTela).And.U_A000VldTOk(),oDlg:End(),nOpcA:=0)},{||oDlg:End()}, nOpcx)
//Ŀ
// Desabilita a Tecla F4                                        
//
SetKey(VK_F4,Nil)

If ( nOpcA == 1 )
	Begin Transaction
		//Ŀ
		// Efetua tratamento do Bonus                                   
		//
		
		cNumAnt := M->CJ_NUM
		A000Bonus(1)
		If Type("lOnUpDate") == "U" .Or. lOnUpdate
			If ( A000Grava(1) )
				//Ŀ
				// Seta a varivel de numero ( chamada do FATA300 )              
				//
				cNumOrc := M->CJ_NUM
				While GetSX8Len() > nStack
					ConfirmSX8()
				EndDo
				EvalTrigger()       
				//Ŀ
				// Exibe mensagem caso tenha alterado o numero do orcamento     
				//
				If ( cNumAnt <> M->CJ_NUM )			
					If !( Type("l415Auto") <> "U" .And. l415Auto )
						Help(" ",1,"NUMSEQ",,M->CJ_NUM,4,15)
					EndIf     
				EndIf 								
				MEnviaMail("026",{SCJ->CJ_NUM,SCJ->CJ_CLIENTE,SCJ->CJ_LOJA,SA1->A1_NOME})									
			EndIf
		Else
			aAutoCab := MsAuto2Ench("SCJ")
			aAutoItens := MsAuto2GDb(aHeader,"TMP1")	
		EndIf
	End Transaction
Else
	While GetSX8Len() > nStack
		RollBackSX8()
	EndDo
EndIf               

A000DesMonta(@cArqSCK,@cArqSCL)
MsUnLockAll()
RestArea(aArea)
Return(.T.)

/*/


Ŀ
Funo    A000Visual Autor                         Data           
Ĵ
Descrio  Programa de Visualizacao de Orcamentos de Venda            
Ĵ
Sintaxe e  Void A000Visual(ExpC1,ExpN1,ExpN2)                         
Ĵ
Parametros ExpC1 = Alias do arquivo                                   
           ExpN1 = Numero do registro                                 
           ExpN2 = Opcao selecionada                                  
Ĵ
 Uso       GIVIA000                                                   
ٱ


/*/
User Function A000Visual(cAlias,nReg,nOpcx)

Local aArea		:= GetArea()
Local nX		:= 0
Local cArqSCL	:= ""
Local cArqSCK	:= ""
Local oSay
Local oDlg
Local oGetDb
Local aPosObj   := {}
Local aObjects  := {}
Local aSize     := {}
Local aPosGet   := {}
Local aInfo     := {}
Local nGetLin   := 0
Private aTela[0][0]
Private aGets[0]
Private bCampo		:= { |nField| Field(nField) }
Private aHeader		:= {}
Private aHeaderSCL	:= {}
Private aHeaderSCK	:= {}
//Ŀ
// Inicializa as Variaveis da Enchoice                          
//
dbSelectArea("SCJ")
For nX:= 1 To FCount()
	M->&(EVAL(bCampo,nX)) := FieldGet(nX)
Next nX
//Ŀ
// Monta aHeader                                                
//
A000Monta(@cArqSCK,@cArqSCL,.F.)
aHeader := aHeaderSCK
//Ŀ
// Faz o calculo automatico de dimensoes de objetos     
//
aSize := MsAdvSize()

aObjects := {}
AAdd( aObjects, { 100, 100, .t., .t. } )
AAdd( aObjects, { 100, 100, .t., .t. } )
AAdd( aObjects, { 100, 015, .t., .f. } )

aInfo := { aSize[ 1 ], aSize[ 2 ], aSize[ 3 ], aSize[ 4 ], 3, 3 }
aPosObj := MsObjSize( aInfo, aObjects )

aPosGet := MsObjGetPos(aSize[3]-aSize[1],315,;
	{{005,070,110,175,215,280}} )
nGetLin := aPosObj[3,1]

DEFINE MSDIALOG oDlg TITLE OemtoAnsi("Pedidos de Venda - Representante") From aSize[7],0 to aSize[6],aSize[5] of oMainWnd PIXEL
EnChoice( "SCJ", nReg,nOpcx,,,,,aPosObj[1],,3,,,,,,.F.)
oGetDb := MsGetDB():New(aPosObj[2,1],aPosObj[2,2],aPosObj[2,3],aPosObj[2,4],nOpcx,"U_A000LinOk","U_A000TudOk","+CK_ITEM",.T., , ,.T., ,"TMP1")
Private oGetDad := oGetDb
@ nGetLin,aPosGet[1,1] SAY oSay PROMPT OemToAnsi("Total do Pedido") 	SIZE 060,009 PIXEL OF oDlg
@ nGetLin,aPosGet[1,3] SAY oSay PROMPT OemToAnsi("Descontos ")			SIZE 060,009 PIXEL OF oDlg
@ nGetLin,aPosGet[1,5] SAY oSay PROMPT OemToAnsi("=")					SIZE 060,009 PIXEL OF oDlg
@ nGetLin,aPosGet[1,2] SAY oSay PROMPT 0    							SIZE 040,009 PICTURE PesqPict("SCK","CK_VALOR",16) PIXEL OF oDlg
oSay:Cargo := "Valor"
@ nGetLin,aPosGet[1,4] SAY oSay PROMPT 0    							SIZE 040,009 PICTURE PesqPict("SCK","CK_VALOR",14) PIXEL OF oDlg
oSay:Cargo := "Desconto"
@ nGetLin,aPosGet[1,6] SAY oSay PROMPT 0                    			SIZE 040,009 PICTURE PesqPict("SCK","CK_VALOR",16) PIXEL OF oDlg
oSay:Cargo := "Total"
A000Total(oDlg)
ACTIVATE MSDIALOG oDlg ON INIT Ma000Bar(oDlg,{||nOpcA:=1,IIf(oGetDb:TudoOk(),oDlg:End(),nOpcA:=0)},{||oDlg:End()}, nOpcx)
A000DesMonta(@cArqSCK,@cArqSCL)
MsUnLockAll()
RestArea(aArea)
Return(.T.)

/*/


Ŀ
Funo    A000Altera Autor                         Data           
Ĵ
Descrio  Programa de Alteracao de Orcamentos de Venda               
Ĵ
Sintaxe    Void A000Altera(ExpC1,ExpN1,ExpN2)                         
Ĵ
Parametros ExpC1 = Alias do arquivo                                   
           ExpN1 = Numero do registro                                 
           ExpN2 = Opcao selecionada                                  
Ĵ
 Uso       GIVIA000                                                   
ٱ


/*/
User Function A000Altera(cAlias,nReg,nOpcx)

Local aArea		:= GetArea()
Local nX		:= 0
Local nOpcA		:= 0
Local nStack    := GetSX8Len() 
Local lContinua	:= .T.
Local cArqSCL	:= ""
Local cArqSCK	:= ""
Local oDlg
Local oSay
Local oGetDb
Local aPosObj   := {}
Local aObjects  := {}
Local aSize     := {}
Local aPosGet   := {}
Local aInfo     := {}
Local nGetLin   := 0
Private aTela[0][0]
Private aGets[0]
Private bCampo := { |nField| Field(nField) }
Private aHeader 	:= {}
Private aHeaderSCL:= {}
Private aHeaderSCK:= {}

l415Auto := If(Type("l415Auto")<>"U",l415Auto,.F.)

//Ŀ
// VerIfica se o Orcamento pode ser Alterado                    
//
If !( SCJ->CJ_STATUS	$	"A#B#C#D" )
	//Ŀ
	// Inicializa as Variaveis da Enchoice                          
	//
	dbSelectArea("SCJ")
	lContinua := SoftLock("SCJ")
	For nX:= 1 To FCount()
		M->&(EVAL(bCampo,nX)) := FieldGet(nX)
	Next nX
	//Ŀ
	// Monta aHeader                                                
	//
	If A000Monta(@cArqSCK,@cArqSCL,.F.,{|a,b| MaCanAltOrc(a,b) })
		aHeader := aHeaderSCK	
		//Ŀ
		// Faz o calculo automatico de dimensoes de objetos     
		//
		aSize := MsAdvSize()

		aObjects := {}
		AAdd( aObjects, { 100, 100, .t., .t. } )
		AAdd( aObjects, { 100, 100, .t., .t. } )
		AAdd( aObjects, { 100, 015, .t., .f. } )

		aInfo := { aSize[ 1 ], aSize[ 2 ], aSize[ 3 ], aSize[ 4 ], 3, 3 }
		aPosObj := MsObjSize( aInfo, aObjects )

		aPosGet := MsObjGetPos(aSize[3]-aSize[1],315,;
			{{005,070,110,175,215,280}} )
		nGetLin := aPosObj[3,1]

		//Ŀ
		// Desabilita a Tecla F4                                        
		//
		SetKey(VK_F4,Nil)

		DEFINE MSDIALOG oDlg TITLE OemtoAnsi("Pedido de Venda - Representante") From aSize[7],0 to aSize[6],aSize[5] of oMainWnd PIXEL
		EnChoice( "SCJ" ,nReg,nOpcx,,,,,aPosObj[1],,3,,,"U_A000VldTOk",,,.F.)
		oGetDb := MsGetDB():New(aPosObj[2,1],aPosObj[2,2],aPosObj[2,3],aPosObj[2,4],nOpcx,"U_A000LinOk","U_A000TudOk","+CK_ITEM",.T., , ,.T., ,"TMP1")
		Private oGetDad := oGetDb
		@ nGetLin,aPosGet[1,1] SAY oSay PROMPT OemToAnsi("Total do Pedido ") 	SIZE 060,009 PIXEL OF oDlg
		@ nGetLin,aPosGet[1,3] SAY oSay PROMPT OemToAnsi("Descontos ") 			SIZE 060,009 PIXEL OF oDlg 
		@ nGetLin,aPosGet[1,5] SAY oSay PROMPT OemToAnsi("=")        			SIZE 060,009 PIXEL OF oDlg
		@ nGetLin,aPosGet[1,2] SAY oSay PROMPT 0    							SIZE 040,009 PICTURE PesqPict("SCK","CK_VALOR",16) PIXEL OF oDlg
		oSay:Cargo := "Valor"
		@ nGetLin,aPosGet[1,4] SAY oSay PROMPT 0    							SIZE 040,009 PICTURE PesqPict("SCK","CK_VALOR",14) PIXEL OF oDlg
		oSay:Cargo := "Desconto"
		@ nGetLin,aPosGet[1,6] SAY oSay PROMPT 0                     			SIZE 040,009 PICTURE PesqPict("SCK","CK_VALOR",16) PIXEL OF oDlg
		oSay:Cargo := "Total"
		//Ŀ
		// Deleta os bonus para reavaliacao                             
		//
		A000Bonus(2)
		A000Total(oDlg)
		ACTIVATE MSDIALOG oDlg ON INIT Ma000Bar(oDlg,{||nOpcA:=1,IIf(U_A000VldTOk().And.oGetDb:TudoOk().And.Obrigatorio(aGets,aTela),oDlg:End(),nOpcA:=0)},{||oDlg:End()},nOpcx)
		//Ŀ
		// Desabilita a Tecla F4                                        
		//
		SetKey(VK_F4,Nil)
	EndIf
	If ( nOpcA == 1 )
		//Ŀ
		// Efetua tratamento do Bonus                                   
		//
		A000Bonus(1)
		If Type("lOnUpDate") == "U" .Or. lOnUpdate
			Begin Transaction
				dbSelectArea(cAlias)
				MsGoto(nReg)
				If ( A000Grava(2) )
					EvalTrigger()
					While GetSX8Len() > nStack 
						ConfirmSX8()
					EndDo
				EndIf
			End Transaction
		Else
			aAutoCab := MsAuto2Ench("SCJ")
			aAutoItens := MsAuto2GDb(aHeader,"TMP1")	
		EndIf
	Else
		While GetSX8Len() > nStack 
			RollBackSX8()
		EndDo
	EndIf
	
	A000DesMonta(@cArqSCK,@cArqSCL)
Else
	Alert("Pedido NAO pode ser Alterado, Verifique!!!")
EndIf
MsUnLockAll()
RestArea(aArea)
Return(.T.)

/*/


Ŀ
Funo    A000Exclui Autor                         Data           
Ĵ
Descrio  Programa de Alteracao de Orcamentos de Venda               
Ĵ
Sintaxe    Void A000Exclui(ExpC1,ExpN1,ExpN2)                         
Ĵ
Parametros ExpC1 = Alias do arquivo                                   
           ExpN1 = Numero do registro                                 
           ExpN2 = Opcao selecionada                                  
Ĵ
 Uso       GIVIA000                                                   
ٱ


/*/
User Function A000Exclui(cAlias,nReg,nOpcx)

Local aArea		:= GetArea()
Local nX		:= 0  
Local nStack    := GetSX8Len() 
Local nOpcA		:= 0
Local cArqSCL	:= ""
Local cArqSCK	:= ""
Local lContinua:= .T.
Local oDlg
Local oSay
Local oGetDb
Local aPosObj   := {}
Local aObjects  := {}
Local aSize     := {}
Local aPosGet   := {}
Local aInfo     := {}
Local nGetLin   := 0

Private aTela[0][0]
Private aGets[0]
Private bCampo := { |nField| Field(nField) }
Private aHeader		:= {}
Private aHeaderSCL	:= {}
Private aHeaderSCK	:= {}
l415Auto := If(Type("l415Auto")<>"U",l415Auto,.F.)
//Ŀ
// VerIfica se o Orcamento pode ser Excluido                    
//
If ( SCJ->CJ_STATUS	$	"A#B#C" )
	//Ŀ
	// Inicializa as Variaveis da Enchoice                          
	//
	dbSelectArea("SCJ")
	lContinua := Softlock("SCJ")
	For nX:= 1 To FCount()
		M->&(EVAL(bCampo,nX)) := FieldGet(nX)
	Next nX
	//Ŀ
	// Monta aHeader                                                
	//
	If A000Monta(@cArqSCK,@cArqSCL,.F.,{|a,b| MaCanDelOrc(a,b) })
		aHeader := aHeaderSCK

		//Ŀ
		// Faz o calculo automatico de dimensoes de objetos     
		//
		aSize := MsAdvSize()

		aObjects := {}
		AAdd( aObjects, { 100, 100, .t., .t. } )
		AAdd( aObjects, { 100, 100, .t., .t. } )
		AAdd( aObjects, { 100, 015, .t., .f. } )

		aInfo := { aSize[ 1 ], aSize[ 2 ], aSize[ 3 ], aSize[ 4 ], 3, 3 }
		aPosObj := MsObjSize( aInfo, aObjects )

		aPosGet := MsObjGetPos(aSize[3]-aSize[1],315,;
			{{005,070,110,175,215,280}} )
		nGetLin := aPosObj[3,1]

		DEFINE MSDIALOG oDlg TITLE OemtoAnsi("Pedidos de Vendas - Representantes") From aSize[7],0 to aSize[6],aSize[5] of oMainWnd PIXEL
		EnChoice("SCJ",nReg,nOpcx,,,,,APosObj[1],,3,,,,,,.F.)
		oGetDb := MsGetDB():New(aPosObj[2,1],aPosObj[2,2],aPosObj[2,3],aPosObj[2,4],nOpcx,"U_A000LinOk","U_A000TudOk","+CK_ITEM",.T., , ,.T., ,"TMP1")
		Private oGetDad := oGetDb			
		@ nGetLin,aPosGet[1,1] SAY oSay PROMPT OemToAnsi("Total do Pedido ") 	SIZE 060,009 PIXEL OF oDlg
		@ nGetLin,aPosGet[1,3] SAY oSay PROMPT OemToAnsi("Descontos ") 			SIZE 060,009 PIXEL OF oDlg
		@ nGetLin,aPosGet[1,5] SAY oSay PROMPT OemToAnsi("=")        			SIZE 060,009 PIXEL OF oDlg
		@ nGetLin,aPosGet[1,2] SAY oSay PROMPT 0    							SIZE 040,009 PICTURE PesqPict("SCK","CK_VALOR",16) PIXEL OF oDlg
		oSay:Cargo := "Valor"
		@ nGetLin,aPosGet[1,4] SAY oSay PROMPT 0    							SIZE 040,009 PICTURE PesqPict("SCK","CK_VALOR",14) PIXEL OF oDlg
		oSay:Cargo := "Desconto"
		@ nGetLin,aPosGet[1,6] SAY oSay PROMPT 0                     			SIZE 040,009 PICTURE PesqPict("SCK","CK_VALOR",16) PIXEL OF oDlg
		oSay:Cargo := "Total"
		A000Total(oDlg)
		ACTIVATE MSDIALOG oDlg ON INIT Ma000Bar(oDlg,{||nOpcA:=1,IIf(oGetDb:TudoOk(),oDlg:End(),nOpcA:=0)},{||oDlg:End()},nOpcx)
	EndIf
	If ( nOpcA == 1 )
		If Type("lOnUpDate") == "U" .Or. lOnUpdate
			Begin Transaction
				If ( A000Grava(3) )
					EvalTrigger()
					While GetSX8Len() > nStack 
						ConfirmSX8()
					EndDo
				EndIf
			End Transaction
		Else
			aAutoCab   := MsAuto2Ench("SCJ")
			aAutoItens := MsAuto2GDb(aHeader,"TMP1")			
		EndIf
	Else
		While GetSX8Len() > nStack 
			RollBackSX8()
		EndDo 
	EndIf               
	
	A000DesMonta(@cArqSCK,@cArqSCL)
Else
	Alert("Pedido NAO pode ser Excluido, Verifique!!!")
EndIf
MsUnLockAll()
RestArea(aArea)
Return(.T.)

/*


Ŀ
Funo    A000Libera   Autor                       Data 22/05/2000
Ĵ
Descrio  Alteracao da tabela de precos com base na tabela do cliente
Ĵ
Sintaxe    A000Libera()                                               
Ĵ
Parametros Nenhum                                                     
Ĵ
Retorno    Nil                                                        
Ĵ
 Uso       GIVIA000                                                   
ٱ


*/

User Function A000Libera(cAlias,nReg,nOpcx)

Local lRet		:=	.T.
Local aArea		:= GetArea()
Local nX		:= 0   
Local nOpcA		:= 0
Local cArqSCL	:= ""
Local cArqSCK	:= ""
Local oSay
Local oDlg
Local oGetDb
Local aPosObj   := {}
Local aObjects  := {}
Local aSize     := {}
Local aPosGet   := {}
Local aInfo     := {}
Local nGetLin   := 0
Private aTela[0][0]
Private aGets[0]
Private bCampo		:= { |nField| Field(nField) }
Private aHeader		:= {}
Private aHeaderSCL	:= {}
Private aHeaderSCK	:= {}
//Ŀ
// Inicializa as Variaveis da Enchoice                          
//
dbSelectArea("SCJ")
For nX:= 1 To FCount()
	M->&(EVAL(bCampo,nX)) := FieldGet(nX)
Next nX
//Ŀ
// Monta aHeader                                                
//
A000Monta(@cArqSCK,@cArqSCL,.F.)
aHeader := aHeaderSCK
//Ŀ
// Faz o calculo automatico de dimensoes de objetos     
//
aSize := MsAdvSize()

aObjects := {}
AAdd( aObjects, { 100, 100, .t., .t. } )
AAdd( aObjects, { 100, 100, .t., .t. } )
AAdd( aObjects, { 100, 015, .t., .f. } )

aInfo := { aSize[ 1 ], aSize[ 2 ], aSize[ 3 ], aSize[ 4 ], 3, 3 }
aPosObj := MsObjSize( aInfo, aObjects )

aPosGet := MsObjGetPos(aSize[3]-aSize[1],315,;
	{{005,070,110,175,215,280}} )
nGetLin := aPosObj[3,1]

DEFINE MSDIALOG oDlg TITLE OemtoAnsi("Pedidos de Venda - Representante") From aSize[7],0 to aSize[6],aSize[5] of oMainWnd PIXEL
EnChoice( "SCJ", nReg,nOpcx,,,,,aPosObj[1],,3,,,,,,.F.)
oGetDb := MsGetDB():New(aPosObj[2,1],aPosObj[2,2],aPosObj[2,3],aPosObj[2,4],nOpcx,"U_A000LinOk","U_A000TudOk","+CK_ITEM",.T., , ,.T., ,"TMP1")
Private oGetDad := oGetDb
@ nGetLin,aPosGet[1,1] SAY oSay PROMPT OemToAnsi("Total do Pedido") 	SIZE 060,009 PIXEL OF oDlg
@ nGetLin,aPosGet[1,3] SAY oSay PROMPT OemToAnsi("Descontos ")			SIZE 060,009 PIXEL OF oDlg
@ nGetLin,aPosGet[1,5] SAY oSay PROMPT OemToAnsi("=")					SIZE 060,009 PIXEL OF oDlg
@ nGetLin,aPosGet[1,2] SAY oSay PROMPT 0    							SIZE 040,009 PICTURE PesqPict("SCK","CK_VALOR",16) PIXEL OF oDlg
oSay:Cargo := "Valor"
@ nGetLin,aPosGet[1,4] SAY oSay PROMPT 0    							SIZE 040,009 PICTURE PesqPict("SCK","CK_VALOR",14) PIXEL OF oDlg
oSay:Cargo := "Desconto"
@ nGetLin,aPosGet[1,6] SAY oSay PROMPT 0                    			SIZE 040,009 PICTURE PesqPict("SCK","CK_VALOR",16) PIXEL OF oDlg
oSay:Cargo := "Total"

A000Total(oDlg)

ACTIVATE MSDIALOG oDlg ON INIT Ma000Bar(oDlg,{||nOpcA:=1,IIf(oGetDb:TudoOk(),oDlg:End(),nOpcA:=0)},{||oDlg:End()}, nOpcx)

If ( nOpcA == 1 )

	_aAreaSCJ	:= GetArea("SCJ")
	_aAreaSCK	:= GetArea("SCK")
	
	DbSelectArea("SCK") 
	
	While !EOF() .and. SCJ->CJ_NUM == SCK->CK_NUM 
		IF SCK->CK_QTDVEN == 0 .OR. SCK->CK_VALOR == 0 
			lRet	:= .F.
		EndIF
		DbSkip()
	EndDo            
	
	RestArea(_aAreaSCK)
	RestArea(_aAreaSCJ)
	
	IF lRet
		Begin Transaction
			RecLock("SCJ",.F.)
			SCJ->CJ_STATUS	:=	"A"
			MsUnLock()
		End Transaction
	Else
		Alert("Este pedido no pode ser liberado, por favor verifique as quantidades e o valor total dos itens.")
	EndIF
	
	GVRMail(SCJ->CJ_NUM)
	
EndIF

A000DesMonta(@cArqSCK,@cArqSCL)

MsUnLockAll()
RestArea(aArea)
Return(.T.)

/*/


Ŀ
Funo     GVRMail   Autor  Gerardo Martinez       Data 13.08.07  
Ĵ
Descrio  Programa de Envio de E-mail, avisando do pedido liberado.  
Ĵ
Sintaxe    Void GVRMail(ExpC1)                                        
Ĵ
Parametros ExpC1 = Numero do Pedido Liberado                          
                                                                      
                                                                      
Ĵ
 Uso       GIVIA000                                                   
ٱ


/*/
Static Function GVRMail(cPedido)

Local _cMsg			:=	""
Local _cSubject 	:=	""
Local _MailServer	:=	""
Local lResult		:=	.T.

//Prepare environment empresa '99' filial '01'

_cMsg 		:= "O Pedido: "+cPedido+" do Representante "+SubStr(cUsuario,7,15)+" acaba de ser liberado."
_cSubject 	:= "Pedido "+cPedido+" de Representante foi Liberado "

ConOut("Enviando E-mail para pedidos@circuit.com.br")

CONNECT SMTP 							;
	 	SERVER 	 GetMV("MV_RELSERV")	; 	// Nome do servidor de e-mail 
     	ACCOUNT  GetMV("MV_RELACNT")	; 	// Nome da conta a ser usada no e-mail 
     	PASSWORD GetMV("MV_RELPSW") 	; 	// Senha
     	RESULT   lResult            	 	// Resultado da tentativa de conexo

If !lResult
	//Ŀ
	// Nao foi possivel estabelecer conexao com o servidor 
	//
	Alert(MailGetErr())
EndIF    

IF lResult
	//Ŀ
	// Conectei ao Servidor, enviando o e-mail para a GIVI 
	//
    ConOut("Autenticando") 
	MailAuth(GetMV("MV_RELACNT"),GetMV("MV_RELPSW"))

	Conout("Conectando...")                   
	
	Remetente	:=	UsrRetMail(__CUSERID)

	Remetente	:=	IIF(Empty(Remetente),"moto@circuit.com.br",Remetente)
	
	Send mail 					;	//	envia e-mail
	from Remetente				;	//	de
	to "pedidos@circuit.com.br;sara@circuit.com.br" ;	//	para
	bcc "gerardo@circuit.com.br";	//	bcc - teste
	subject _cSubject 			;	//	assunto
	body _cMsg 					;	//	mensagem
	FORMAT TEXT						//	formato do texto
	
	ConOut("Enviando...")
	
	GET MAIL ERROR cErrorMsg
	
	ConOut("Verificando Erros...")
	ConOut(cErrorMsg)

EndIf

DISCONNECT SMTP SERVER

Return()

/*/


Ŀ
Funo    A000Copia  Autor                         Data           
Ĵ
Descrio  Programa de Copia dos Orcamentos de Venda                  
Ĵ
Sintaxe    Void A000Copia (ExpC1,ExpN1,ExpN2)                         
Ĵ
Parametros ExpC1 = Alias do arquivo                                   
           ExpN1 = Numero do registro                                 
           ExpN2 = Opcao selecionada                                  
Ĵ
 Uso       GIVIA000                                                   
ٱ


/*/
User Function A000Copia(cAlias,nReg,nOpcx)

Local aArea		:= GetArea()
Local nX		:= 0
Local nOpcA		:= 0
Local nStack    := GetSX8Len() 
Local cArqSCL	:= ""
Local cArqSCK	:= ""
Local lMt415Cpy := ExistBlock("MT415CPY")
Local oDlg
Local oSay
Local oGetDB
Local aPosObj   := {}
Local aObjects  := {}
Local aSize     := {}
Local aPosGet   := {}
Local aInfo     := {}
Local aCposCopy := {}
Local nGetLin   := 0

Private aTela[0][0]
Private aGets[0]
Private bCampo := { |nField| Field(nField) }
Private aHeader 	:= {}
Private aHeaderSCL	:= {}
Private aHeaderSCK	:= {}

If ( xFilial("SCJ") == SCJ->CJ_FILIAL )
	//Ŀ
	// Inicializa as Variaveis da Enchoice                          
	//
	
	If lMt415Cpy
		aCposCopy := ExecBlock("MT415CPY",.F.,.F.)
	Endif	
	
	dbSelectArea("SCJ")
	For nX:= 1 To FCount()
		If Ascan(aCposCopy, EVAL(bCampo,nX) ) == 0
			M->&(EVAL(bCampo,nX)) := FieldGet(nX)
		Else	                                  
			M->&(EVAL(bCampo,nX)) := CriaVar(EVAL(bCampo,nX),.T.)
		Endif	
	Next nX
	M->CJ_NUM := CriaVar("CJ_NUM",.T.)
	M->CJ_EMISSAO := dDataBase
	//Ŀ
	// Monta aHeader                                                
	//
	A000Monta(@cArqSCK,@cArqSCL,.F.,,,.T.)	
	aHeader := aHeaderSCK
	//Ŀ
	// Desabilita a Tecla F4                                        
	//
	SetKey(VK_F4,Nil)
	//Ŀ
	// Faz o calculo automatico de dimensoes de objetos     
	//
	aSize := MsAdvSize()

	aObjects := {}
	AAdd( aObjects, { 100, 100, .t., .t. } )
	AAdd( aObjects, { 100, 100, .t., .t. } )
	AAdd( aObjects, { 100, 015, .t., .f. } )

	aInfo := { aSize[ 1 ], aSize[ 2 ], aSize[ 3 ], aSize[ 4 ], 3, 3 }
	aPosObj := MsObjSize( aInfo, aObjects )

	aPosGet := MsObjGetPos(aSize[3]-aSize[1],315,;
		{{005,070,110,175,215,280}} )
	nGetLin := aPosObj[3,1]

	DEFINE MSDIALOG oDlg TITLE OemtoAnsi("Pedido de Vendas - Representante ") From aSize[7],0 to aSize[6],aSize[5] of oMainWnd PIXEL//"Oramentos de Venda"
	EnChoice( "SCJ" ,nReg,nOpcx,,,,,aPosObj[1],,3,,,"U_A000VldTOk",,,.F.)
	oGetDb := MsGetDB():New(aPosObj[2,1],aPosObj[2,2],aPosObj[2,3],aPosObj[2,4],nOpcx,"U_A000LinOk","U_A000TudOk","+CK_ITEM",.T., , ,.T., ,"TMP1", , ,.F.)
	Private oGetDad := oGetDb	
	@ nGetLin,aPosGet[1,1] SAY oSay PROMPT OemToAnsi("Total do Pedido ") 	SIZE 060,009 PIXEL OF oDlg
	@ nGetLin,aPosGet[1,3] SAY oSay PROMPT OemToAnsi("Descontos ") 			SIZE 060,009 PIXEL OF oDlg
	@ nGetLin,aPosGet[1,5] SAY oSay PROMPT OemToAnsi("=")        			SIZE 060,009 PIXEL OF oDlg //"="
	@ nGetLin,aPosGet[1,2] SAY oSay PROMPT 0    							SIZE 040,009 PICTURE PesqPict("SCK","CK_VALOR",16) PIXEL OF oDlg
	oSay:Cargo := "Valor"
	@ nGetLin,aPosGet[1,4] SAY oSay PROMPT 0    							SIZE 040,009 PICTURE PesqPict("SCK","CK_VALOR",14) PIXEL OF oDlg
	oSay:Cargo := "Desconto"
	@ nGetLin,aPosGet[1,6] SAY oSay PROMPT 0                    			SIZE 040,009 PICTURE PesqPict("SCK","CK_VALOR",16) PIXEL OF oDlg
	oSay:Cargo := "Total"
	A000Total(oDlg)
	ACTIVATE MSDIALOG oDlg ON INIT Ma000Bar(oDlg,{||nOpcA:=1,IIf(oGetDb:TudoOk(),oDlg:End(),nOpcA:=0)},{||oDlg:End()},nOpcx)
	If ( nOpcA == 1 )
		If Type("lOnUpDate") == "U" .Or. lOnUpdate
			Begin Transaction
				If ( A000Grava(1) )
					EvalTrigger()
					While GetSX8Len() > nStack 
						ConfirmSX8()
					EndDo
				EndIf
			End Transaction
		Else
			aAutoCab := MsAuto2Ench("SCJ")
			aAutoItens := MsAuto2GDb(aHeader,"TMP1")			
		EndIf
	Else
		While GetSX8Len() > nStack 
			RollBackSX8()
		EndDo 
	EndIf
	
	A000DesMonta(@cArqSCK,@cArqSCL)
	MsUnLockAll()
EndIf
RestArea(aArea)
Return(.T.)

/*/


Ŀ
Funo    A000Cancel Autor                         Data           
Ĵ
Descrio  Programa de Cancelamento dos Orcamentos de Venda           
Ĵ
Sintaxe e  Void A000Cancel(ExpC1,ExpN1,ExpN2)                         
Ĵ
Parametros ExpC1 = Alias do arquivo                                   
           ExpN1 = Numero do registro                                 
           ExpN2 = Opcao selecionada                                  
Ĵ
 Uso       GIVIA000                                                   
ٱ


/*/
User Function A000Cancel(cAlias,nReg,nOpcx)

Local aArea		:= GetArea()
Local nX		:= 0
Local cArqSCL	:= ""
Local cArqSCK	:= ""
Local nOpcA		:= 0
Local lContinua := .T.
Local oDlg
Local oSay
Local oGetDb

Private aTela[0][0]
Private aGets[0]
Private bCampo := { |nField| Field(nField) }
Private aHeader		:= {}
Private aHeaderSCL	:= {}
Private aHeaderSCK	:= {}

//Ŀ
// Somente pode ser cancelados orcamentos em aberto             
//
If !(SCJ->CJ_STATUS	$	"B#C")
	//Ŀ
	// Inicializa as Variaveis da Enchoice                          
	//
	dbSelectArea("SCJ")
	lContinua := Softlock("SCJ")
	For nX:= 1 To FCount()
		M->&(EVAL(bCampo,nX)) := FieldGet(nX)
	Next nX
	//Ŀ
	// Monta aHeader                                                
	//
	lContinua := A000Monta(@cArqSCK,@cArqSCL,.F.,{|a,b| MaCanAltOrc(a,b) })
	aHeader := aHeaderSCK
	//Ŀ
	//Desabilita a Tecla F4                                         
	//
	SetKey(VK_F4,Nil)
	If  ( lContinua )
		//Ŀ
		// Faz o calculo automatico de dimensoes de objetos     
		//
		aSize := MsAdvSize()

		aObjects := {}
		AAdd( aObjects, { 100, 100, .t., .t. } )
		AAdd( aObjects, { 100, 100, .t., .t. } )
		AAdd( aObjects, { 100, 015, .t., .f. } )

		aInfo := { aSize[ 1 ], aSize[ 2 ], aSize[ 3 ], aSize[ 4 ], 3, 3 }
		aPosObj := MsObjSize( aInfo, aObjects )

		aPosGet := MsObjGetPos(aSize[3]-aSize[1],315,;
			{{005,070,110,175,215,280}} )
		nGetLin := aPosObj[3,1]

		DEFINE MSDIALOG oDlg TITLE OemtoAnsi("Pedido de Vendas - Representante ") From aSize[7],0 to aSize[6],aSize[5] of oMainWnd PIXEL
		EnChoice( "SCJ", nReg,nOpcx,,,,,aPosObj[1],,3,,,,,,.F.)
		oGetDb := MsGetDB():New(aPosObj[2,1],aPosObj[2,2],aPosObj[2,3],aPosObj[2,4],nOpcx,"U_A000LinOk","U_A000TudOk","+CK_ITEM",.T., , ,.T., ,"TMP1")
		Private oGetDad := oGetDb		
		@ nGetLin,aPosGet[1,1] SAY oSay PROMPT OemToAnsi("Total do Pedido ") 	SIZE 060,009 PIXEL OF oDlg 
		@ nGetLin,aPosGet[1,3] SAY oSay PROMPT OemToAnsi("Descontos ") 			SIZE 060,009 PIXEL OF oDlg
		@ nGetLin,aPosGet[1,5] SAY oSay PROMPT OemToAnsi("=")        			SIZE 060,009 PIXEL OF oDlg 
		@ nGetLin,aPosGet[1,2] SAY oSay PROMPT 0    							SIZE 040,009 PICTURE PesqPict("SCK","CK_VALOR",16) PIXEL OF oDlg
		oSay:Cargo := "Valor"
		@ nGetLin,aPosGet[1,4] SAY oSay PROMPT 0    							SIZE 040,009 PICTURE PesqPict("SCK","CK_VALOR",14) PIXEL OF oDlg
		oSay:Cargo := "Desconto"
		@ nGetLin,aPosGet[1,6] SAY oSay PROMPT 0                    			SIZE 040,009 PICTURE PesqPict("SCK","CK_VALOR",16) PIXEL OF oDlg
		oSay:Cargo := "Total"
		A000Total(oDlg)
		ACTIVATE MSDIALOG oDlg ON INIT Ma000Bar(oDlg,{||nOpcA:=1,IIf(oGetDb:TudoOk(),oDlg:End(),nOpcA:=0)},{||oDlg:End()}, nOpcx)
	Else
		Help(" ",1,"A415CANCEL")
	EndIf
	
	If ( nOpcA == 1 )
		Begin Transaction
			dbSelectArea("SCJ")
			RecLock("SCJ",.F.)
			dbSelectArea("SCK")
			dbSetOrder(1)
			MsSeek(xFilial("SCK")+SCJ->CJ_NUM)
			While ( !Eof() .And. SCK->CK_FILIAL==xFilial("SCK") .And.;
					SCK->CK_NUM == SCJ->CJ_NUM )
				MaAvalOrc("SCK",4)
				dbSelectArea("SCK")
				dbSkip()
			EndDo
			MaAvalOrc("SCJ",14)
			MsUnlock()
		End Transaction
	EndIf
	A000DesMonta(@cArqSCK,@cArqSCL)
Else
	Alert("Pedido NAO pode ser Cancelado, Verifique!!!")
EndIf
MsUnLockAll()
RestArea(aArea)
Return(.T.)

/*/


Ŀ
Funo    A000Baixa  Autor                         Data           
Ĵ
Descrio  Programa de Baixa dos Orcamentos de Venda                  
Ĵ
Sintaxe e  Void A000Baixa (ExpC1,ExpN1,ExpN2)                         
Ĵ
Parametros ExpC1 = Alias do arquivo                                   
           ExpN1 = Numero do registro                                 
           ExpN2 = Opcao selecionada                                  
Ĵ
 Uso       GIVIA000                                                   
ٱ


/*/
User Function A000Baixa(cAlias,nReg,nOpcx)

Local aArea		:= GetArea()
Local nX		:= 0
Local cArqSCL	:= ""
Local cArqSCK	:= ""
Local lContinua	:= .T.
Local nOpcA    	:= 0
Local oDlg
Local oSay
Local oGetDb

Local aSize       := {}
Local aPosObj     := {}
Local aPosGet     := {}
Local aInfo       := {}
Local aObjects    := {}
Local nLinGet     := 0
Local lMt415Aut   := Existblock("MT415AUT")

Private aTela[0][0]
Private aGets[0]
Private bCampo 		:= { |nField| Field(nField) }
Private aHeader		:= {}
Private aHeaderSCL	:= {}
Private aHeaderSCK	:= {}

l415Auto := If(Type("l415Auto")<>"U",l415Auto,.F.)
l416Auto := If(Type("l416Auto")<>"U",l416Auto,.F.)

//Ŀ
// Somente pode ser Baixados orcamentos em aberto               
//
If ( SCJ->CJ_STATUS == "A" )

	//Ŀ
	// Inicializa as Variaveis da Enchoice                          
	//
	dbSelectArea("SCJ")
	lContinua := Softlock("SCJ")
	For nX:= 1 To FCount()
		M->&(EVAL(bCampo,nX)) := FieldGet(nX)
	Next nX
	//Ŀ
	// Monta aHeader                                                
	//
	A000Monta(@cArqSCK,@cArqSCL,.F.)
	aHeader := aHeaderSCK

	//Ŀ
	// Desabilita a Tecla F4                                        
	//
	SetKey(VK_F4,Nil)

	//Ŀ
	// Definicao automatica - Tamanho de objetos                    
	//
	aSize := MsAdvSize( , .F. )

	aObjects := {}

	AAdd( aObjects, { 100, 100, .T., .T. } )
	AAdd( aObjects, { 100, 100, .T., .T. } )
	AAdd( aObjects, { 100,  15, .T., .F. } ) 						

	aInfo := { aSize[1], aSize[2], aSize[3], aSize[4], 3, 3 }

	aPosObj := MsObjSize( aInfo, aObjects )

	DEFINE MSDIALOG oDlg TITLE OemtoAnsi("Pedido de Vendas - Representante ") From aSize[7],0 to aSize[6],aSize[5] PIXEL

	EnChoice( "SCJ", nReg,2,,,,,aPosObj[1],,3,,,,,,.F.)
	oGetDb := MsGetDB():New(aPosObj[2,1],aPosObj[2,2],aPosObj[2,3],aPosObj[2,4],2,"U_A000LinOk","U_A000TudOk","+CK_ITEM",.T., , ,.T., ,"TMP1")
	Private oGetDad := oGetDb			

	aPosGet := MsObjGetPos(aPosObj[3,4]-aPosObj[3,2],315,;
		{{005,110,215,070,175,280}} )

	nLinGet := aPosObj[3,1]							

	@ nLinGet,aPosGet[1,1] SAY oSay PROMPT OemToAnsi("Total do Pedido") 	SIZE 060,009 PIXEL OF oDlg
	@ nLinGet,aPosGet[1,2] SAY oSay PROMPT OemToAnsi("Descontos ") 			SIZE 060,009 PIXEL OF oDlg 
	@ nLinGet,aPosGet[1,3] SAY oSay PROMPT OemToAnsi("=")        			SIZE 060,009 PIXEL OF oDlg
	@ nLinGet,aPosGet[1,4] SAY oSay PROMPT 0    							SIZE 040,009 PICTURE PesqPict("SCK","CK_VALOR",16) PIXEL OF oDlg
	oSay:Cargo := "Valor"
	@ nLinGet,aPosGet[1,5] SAY oSay PROMPT 0    							SIZE 040,009 PICTURE PesqPict("SCK","CK_VALOR",14) PIXEL OF oDlg
	oSay:Cargo := "Desconto"
	@ nLinGet,aPosGet[1,6] SAY oSay PROMPT 0                     			SIZE 040,009 PICTURE PesqPict("SCK","CK_VALOR",16) PIXEL OF oDlg
	oSay:Cargo := "Total"
	A000Total(oDlg)
	ACTIVATE MSDIALOG oDlg ON INIT Ma000Bar(oDlg,{||nOpcA:=1,oDlg:End()},{||oDlg:End()},nOpcx)

	If ( nOpcA == 1 )
		Begin Transaction
			a416GrvBx()
		End Transaction
	EndIf

	A000DesMonta(@cArqSCK,@cArqSCL)

Else
	Alert("Pedido NAO pode ser Baixado, Verifique!!!")
EndIf

MsUnLockAll()
RestArea(aArea)
Return(.F.)

/*/


Ŀ
Funo    A000Monta    Autor                       Data           
Ĵ
Descrio  Monta aHeader e aCols dos arquivos Temporarios             
Ĵ
Sintaxe    Void A000Monta(Void)                                       
Ĵ
ParametrosExpC1: Arquivo temporario SCK                               
          ExpC2: Arquivo temporario SCL                               
          ExpL3: Indica se esta no modulo de inclusao                 
          ExpB4: CodeBlock a ser avaliado para o retorno da funcao    
          ExpL5: Indica se os campos de Cotacao devem ser habilitados 
Ĵ
Retorno    ExpL1: Conforme indicado pelo CodeBlock em ExpB4, quando o 
           este indicar .F., a execucao da funcao sera interrompida.  
           Para o codeblock sera informado o alias do SCJ e do SCK.   
Ĵ
 Uso       GIVIA000                                                   
ٱ


/*/
Static Function A000Monta(cArqSCK,cArqSCL,lInclui,bBlock,lCotacao, lCopia)

Local aArea    := GetArea()
Local aAreaSCK := SCK->(GetArea())
Local aAreaSCL := SCL->(GetARea())
Local aCampos  := {}
Local aCpoNCopia := {"CK_NUMPV","CK_NUMOP","CK_CONTRAT","CK_ITEMCON"}
Local cAliasSCK:= "SCK"
Local cAliasSCL:= "SCL"

Local cChave   := ""
Local nUsado   := 0
Local nX       := 0

Local lQuery   := .F.
Local lRetorno := .T.

#IFDEF TOP
	Local aStruSCK := SCK->(dbStruct())
	Local aStruSCL := SCL->(dbStruct())
	Local cQuery   := ""
#ENDIF

DEFAULT lCotacao := !Empty(lCotacao)
DEFAULT bBlock   := {|| .T.}
DEFAULT aStackTMP:= {}
DEFAULT lCopia   := .F.

//Ŀ
// Monta aHeader do SCK                                         
//
aHeader := {}
aCampos := {}
dbSelectArea("SX3")
dbSetOrder(1)
MsSeek("SCK")
nUsado := 0
While ( !Eof() .And. SX3->X3_ARQUIVO == "SCK" )
	If ( X3USO(SX3->X3_USADO) .And. cNivel >= SX3->X3_NIVEL ) 
		AADD(aHeader,{ AllTrim(SX3->(X3Titulo())),;
			SX3->X3_CAMPO,;
			SX3->X3_PICTURE,;
			SX3->X3_TAMANHO,;
			SX3->X3_DECIMAL,;
			SX3->X3_VALID,;
			SX3->X3_USADO,;
			SX3->X3_TIPO,;
			SX3->X3_ARQUIVO,;
			SX3->X3_CONTEXT } )
		aadd(aCampos,{SX3->X3_CAMPO,SX3->X3_TIPO,SX3->X3_TAMANHO,SX3->X3_DECIMAL})
		nUsado++
	EndIf
	dbSelectArea("SX3")
	dbSkip()
EndDo
aadd(aCampos,{"CK_FLAG","L",1,0})
//Ŀ
// Verifica se o TMP1 esta aberto                               
//
If Select("TMP1")<>0
	dbSelectArea("TMP1")
	dbCloseArea()
EndIf
//Ŀ
// Monta arquivo de Trabalho TMP1                               
//
dbSelectArea("SCK")
dbSetOrder(1)
cChave  := "CK_ITEM+CK_PRODUTO"
cArqSCK := CriaTrab(aCampos,.T.)
dbUseArea(.T.,,cArqSCK,"TMP1",.F.,.F.)
dbSelectArea("TMP1")
aHeaderSCK := aClone(aHeader)
//Ŀ
// Guarda o TMP1 na Pilha - Utilizado no Sales Tracker          
//
aadd(aStackTMP ,{cArqSCK,"",""})
//Ŀ
// Preenchimento do arquivo temporario                          
//
If ( !lInclui )
	#IFDEF TOP
		If ( TcSrvType() <> "AS/400" )
		
			dbSelectArea("SCK")
			dbSetOrder(1)
		
			lQuery    := .T.
			cAliasSCK := "SCKA415"
			cQuery := "SELECT SCK.*,SCK.R_E_C_N_O_ SCKRECNO "
			cQuery += "FROM "+RetSqlName("SCK")+" SCK "
			cQuery += "WHERE "
			cQuery += "SCK.CK_FILIAL='"+xFilial("SCK")+"' AND "
			cQuery += "SCK.CK_NUM='"+SCJ->CJ_NUM+"' AND "
			cQuery += "SCK.D_E_L_E_T_<>'*'"
			cQuery += "ORDER BY "+SqlOrder(SCK->(IndexKey()))			
			
			cQuery := ChangeQuery(cQuery)

			dbUseArea(.T.,"TOPCONN",TcGenQry(,,cQuery),cAliasSCK,.T.,.T.)
			For nX := 1 To Len(aStruSCK)
				If ( aStruSCK[nX][2] <> "C" )
					TcSetField(cAliasSCK,aStruSCK[nX][1],aStruSCK[nX][2],aStruSCK[nX][3],aStruSCK[nX][4])
				EndIf
			Next nX
		Else
	#ENDIF
		dbSelectArea("SCK")
		dbSetOrder(1)
		MsSeek(xFilial()+SCJ->CJ_NUM,.T.)
		#IFDEF TOP	
		EndIf
		#ENDIF
	While ( ! Eof() .And. xFilial("SCK") == (cAliasSCK)->CK_FILIAL .And.;
			(cAliasSCK)->CK_NUM == SCJ->CJ_NUM )
		If ( Eval(bBlock,"SCJ",cAliasSCK) )
			dbSelectArea("TMP1")
			RecLock("TMP1",.T.)
			For nX := 1 To Len(aHeaderSCK)
				If ( aHeaderSCK[nX][08] <> "M" .And. aHeaderSCK[nX][10] <> "V" .And. Iif(lCopia,Empty( Ascan( aCpoNCopia, { |x| x == Alltrim(aHeaderSCK[nX][2]) } ) ),.T.) )				
					FieldPut(FieldPos(aHeaderSCK[nX][2]),(cAliasSCK)->(FieldGet(FieldPos(aHeaderSCK[nX][2]))))					
				Else
					If ( lQuery )
						SCK->(MsGoto((cAliasSCK)->SCKRECNO))
					EndIf
					If ( aHeaderSCK[nX][10] <> "V" ) .And. Iif(lCopia,Empty( Ascan( aCpoNCopia, { |x| x == Alltrim(aHeaderSCK[nX][2]) } ) ),.T.) 					
						FieldPut(FieldPos(aHeaderSCK[nX][2]),SCK->(FieldGet(FieldPos(aHeaderSCK[nX][2]))))						
					Else
						FieldPut(FieldPos(aHeaderSCK[nX][2]),CriaVar(aHeaderSCK[nX][2],.T.))						
					EndIf
				EndIf
			Next nX
			MsUnlock()
		Else
			lRetorno := .F.
			Exit
		EndIf
		dbSelectArea(cAliasSCK)
		dbSkip()
	EndDo
	If ( lQuery )
		dbSelectArea(cAliasSCK)
		dbCloseArea()
		dbSelectArea("SCK")
	EndIf
EndIf
If ( lRetorno )
	//Ŀ
	// Monta aHeader do SCL                                         
	//
	aHeader := {}
	aCampos := {}
	nUsado  := 0
	dbSelectArea("SX3")
	dbSetOrder(1)
	MsSeek("SCL")
	While ( !Eof() .And. SX3->X3_ARQUIVO == "SCL" )
		If ( X3USO(SX3->X3_USADO) .And. cNivel >= SX3->X3_NIVEL )
			AADD(aHeader,{ AllTrim(SX3->(X3Titulo())),;
				SX3->X3_CAMPO,;
				SX3->X3_PICTURE,;
				SX3->X3_TAMANHO,;
				SX3->X3_DECIMAL,;
				SX3->X3_VALID,;
				SX3->X3_USADO,;
				SX3->X3_TIPO,;
				SX3->X3_ARQUIVO,;
				SX3->X3_CONTEXT } )
			nUsado++
		EndIf
		aadd(aCampos,{SX3->X3_CAMPO,SX3->X3_TIPO,SX3->X3_TAMANHO,SX3->X3_DECIMAL})
		dbSelectArea("SX3")
		dbSkip()
	EndDo
	aadd(aCampos,{"CL_FLAG","L",1,0})
	//Ŀ
	// Verifica se o TMP2 esta aberto                               
	//
	If Select("TMP2")<>0
		dbSelectArea("TMP2")
		dbCloseArea()
	EndIf
	//Ŀ
	// Monta arquivo de Trabalho TMP2                               
	//
	dbSelectArea("SCL")
	dbSetOrder(1)
	cChave  := "CL_NUM+CL_ITEMORC+CL_ITEM+CL_PRODUTO"
	cArqSCL := CriaTrab(aCampos,.T.)
	dbUseArea(.T.,,cArqSCL,"TMP2",.F.,.F.)
	IndRegua("TMP2",cArqSCL,cChave)
	dbSelectArea("TMP2")
	aHeaderSCL := aClone(aHeader)	
	//Ŀ
	// Guarda o TMP1 na Pilha - Utilizado no Sales Tracker          
	//
	aStackTMP [Len(aStackTMP ),2] := cArqSCL
	aStackTMP [Len(aStackTMP ),3] := cArqSCL
	//Ŀ
	// Preenchimento do arquivo temporario                          
	//	
	If ( !lInclui )
		#IFDEF TOP
			If ( TcSrvType() <> "AS/400" )
				lQuery    := .T.
				cAliasSCL := "SCLA415"
				cQuery := "SELECT SCL.*,SCL.R_E_C_N_O_ SCLRECNO "
				cQuery += "FROM "+RetSqlName("SCL")+" SCL "
				cQuery += "WHERE "
				cQuery += "SCL.CL_FILIAL='"+xFilial("SCL")+"' AND "
				cQuery += "SCL.CL_NUM='"+SCJ->CJ_NUM+"' AND "
				cQuery += "SCL.D_E_L_E_T_<>'*'"

				cQuery := ChangeQuery(cQuery)

				dbUseArea(.T.,"TOPCONN",TcGenQry(,,cQuery),cAliasSCL,.T.,.T.)
				For nX := 1 To Len(aStruSCL)
					If ( aStruSCL[nX][2] <> "C" )
						TcSetField(cAliasSCL,aStruSCL[nX][1],aStruSCL[nX][2],aStruSCL[nX][3],aStruSCL[nX][4])
					EndIf
				Next nX
			Else
		#ENDIF
			dbSelectArea("SCL")
			dbSetOrder(1)
			MsSeek(xFilial()+SCJ->CJ_NUM,.T.)
			#IFDEF TOP
			EndIf	
			#ENDIF			
		While ( ! Eof() .And. xFilial("SCL") == (cAliasSCL)->CL_FILIAL .And.;
				(cAliasSCL)->CL_NUM == SCJ->CJ_NUM )
			dbSelectArea("TMP2")
			RecLock("TMP2",.T.)
			For nX := 1 To Len(aHeaderSCL)
				If ( aHeaderSCL[nX][08] <> "M" .And. aHeaderSCL[nX][10] <> "V" )
					FieldPut(FieldPos(aHeaderSCL[nX][2]),(cAliasSCL)->(FieldGet(FieldPos(aHeaderSCL[nX][2]))))					
				Else
					If ( lQuery )
						SCL->(MsGoto((cAliasSCL)->SCLRECNO))
					EndIf
					If ( aHeaderSCL[nX][10] <> "V" )
						FieldPut(FieldPos(aHeaderSCL[nX][2]),SCL->(FieldGet(FieldPos(aHeaderSCL[nX][2]))))						
					Else
						FieldPut(FieldPos(aHeaderSCL[nX][2]),CriaVar(aHeaderSCL[nX][2],.T.))						
					EndIf
				EndIf
			Next nX
			TMP2->CL_NUM := M->CJ_NUM
			TMP2->CL_ITEMORC := (cAliasSCL)->CL_ITEMORC			
			MsUnlock()
			dbSelectArea(cAliasSCL)
			dbSkip()
		EndDo
		If ( lQuery )
			dbSelectArea(cAliasSCL)
			dbCloseArea()
			dbSelectArea("SCL")
		EndIf
	EndIf
EndIf
RestArea(aAreaSCK)
RestArea(aAreaSCL)
RestArea(aArea)
Return(lRetorno)

/*/


Ŀ
Funo    A000DesMonta Autor                       Data           
Ĵ
Descrio  Desmonta os arquivos temporarios.                          
Ĵ
Sintaxe    Void A000DesMonta( )                                       
Ĵ
ParametrosExpC1: Arquivo temporario SCK                               
          ExpC2: Arquivo temporario SCL                               
Ĵ
 Uso       GIVIA000                                                   
ٱ


/*/
Static Function A000DesMonta(cArqSCK,cArqSCL)


If Select("TMP1")<>0
	dbSelectArea("TMP1")
	dbCloseArea()
	FErase(cArqSCK+GetDBExtension())
	FErase(cArqSCK+OrdBagExt())
EndIf
If Select("TMP2")<>0
	dbSelectArea("TMP2")
	dbCloseArea()
	FErase(cArqSCL+GetDBExtension())
	FErase(cArqSCL+OrdBagExt())
EndIf
//Ŀ
// Controle de Pilha do Sales Tracker - Quando o orcamento e chamada varias vezes 
//
aStackTMP  := aDel(aStackTMP ,Len(aStackTMP ))
aStackTMP  := aSize(aStackTMP ,Len(aStackTMP )-1)
If !Empty(aStackTMP )
	dbUseArea(.T.,,aStackTMP [Len(aStackTMP ),1],"TMP1",.F.,.F.)
	dbUseArea(.T.,,aStackTMP [Len(aStackTMP ),2],"TMP2",.F.,.F.)
	dbSetIndex( aStackTMP [Len(aStackTMP),3] + OrdBagExt() )
EndIf
Return(.T.)

/*/


Ŀ
Funo    A000Grava    Autor                       Data           
Ĵ
Descrio  Grava os Orcamentos de Venda.                              
Ĵ
Sintaxe    Void A000Grava(nExpN1)                                     
Ĵ
Parametros nExpN1 : 1 - Inclusao / 2 - Alteracao / 3 - Excluir        
Ĵ
 Uso       GIVIA000                                                   
ٱ


/*/
Static Function A000Grava(nOpcx)

Local aRecTMP1  := {}

Local nX  := 0
Local nPosField:= 0
Local cItem    := "00"
Local cItemAnt := ""
Local cNumOrc  := ""
Local cMay     := "" 
Local lGravou  := .F.
Local l415Grava:= ExistBlock("M415GRV")
Local nCnt     := 0

//Ŀ
// nOpcx: 1 - Inclusao de Registros                     
// nOpcx: 2 - Alteracao de Registros                    
// nOpcx: 3 - Exclusao de Registros                     
// nOpcx: 6 - Liberacao de Pedidos                      
//
//Ŀ
//Posiciona Cliente                                             
//
dbSelectArea("SA1")
dbSetorder(1)
MsSeek(xFilial("SA1")+M->CJ_CLIENTE+M->CJ_LOJA)
If ( nOpcx == 1 ) // Inclusao     

	//Ŀ
	// Verifica se existe algum item a ser gravado                  
	//
	
	dbSelectArea("TMP1")
	dbGotop()
	While ( !Eof() )
		If ( !TMP1->CK_FLAG .And. !Empty(TMP1->CK_PRODUTO)  )
			lGravou := .T.
			Aadd(aRecTMP1,TMP1->(Recno()))			
		Endif		
		dbSelectArea("TMP1")
		dbSkip()
	EndDo

	dbSelectArea("TMP2")
	dbGotop()       
	While ( !Eof() )	
		If ( !TMP2->CL_FLAG )
			lGravou := .T.
			Exit
		Endif		
		dbSelectArea("TMP2")
		dbSkip()
	EndDo

	//Ŀ
	// Verifica se o numero ja foi gravado                          
	//
	cNumOrc := M->CJ_NUM 
	cMay := "SCJ"+ Alltrim(xFilial("SCJ"))
	SCJ->(dbSetOrder(1))
	While ( SCJ->( DbSeek(xFilial("SCJ")+cNumOrc) ) .or. !MayIUseCode(cMay+cNumOrc) )
		cNumOrc := Soma1(cNumOrc,Len(M->CJ_NUM))
	EndDo
                     
	M->CJ_NUM := cNumOrc 

	//Ŀ
	// Efetua a Gravacao do Cabecario                               
	//
	
	If ( lGravou )
		dbSelectArea("SCJ")
		RecLock("SCJ",.T.)
		For nX := 1 To FCount()
			If ("FILIAL" $ FieldName(nX) )
				FieldPut(nX,xFilial())
			Else
				FieldPut(nX,M->&(FieldName(nX)))
			EndIf
		Next nX
		MaAvalOrc("SCJ",11)
	EndIf

    SCJ->(FkCommit())

	//Ŀ
	// Efetua a Gravacao do Itens                                   
	//
	cItem := "00"
	
	For nCnt := 1 to Len(aRecTMP1)

		TMP1->(MsGoto(aRecTMP1[nCnt]))
	
		dbSelectArea("SCK")
		RecLock("SCK",.T.)
		For nX := 1 To FCount()
			nPosField := TMP1->(FieldPos(SCK->(FieldName(nX))))
			If ( nPosField <> 0 )
				FieldPut(nX,TMP1->(FieldGet(nPosField)))
			EndIf
		Next nX
		SCK->CK_FILIAL := xFilial("SCK")
		SCK->CK_NUM    := M->CJ_NUM
		SCK->CK_CLIENTE:= M->CJ_CLIENTE
		SCK->CK_LOJA   := M->CJ_LOJA
		//Ŀ
		// Aqui  feita a regravao dos itens do SCK E SCL             
		//
		dbSelectArea("TMP2")
		dbSetOrder(1)
		MsSeek(M->CJ_NUM+TMP1->CK_ITEM,.F.)
		cItem := Soma1(cItem)
		If ( Found() )
			TMP2->CL_ITEMORC := cItem
		EndIf
		SCK->CK_ITEM   := cItem
		lGravou        := .T.
		MaAvalOrc("SCK",1)
		
	Next
	
	//Ŀ
	// Efetua a Gravacao dos Sub-itens TMP2                         
	//
	cItem := "00"
	dbSelectArea("TMP2")
	dbGotop()
	While ( !Eof() )
		If ( !TMP2->CL_FLAG .And. lGravou )
			dbSelectArea("SCK")
			dbSetOrder(1)
			MsSeek(xFilial()+TMP2->CL_NUM+TMP2->CL_ITEMORC,.F.)
			If ( Found() )
				dbSelectArea("SCL")
				RecLock("SCL",.T.)
				For nX := 1 To FCount()
					nPosField := TMP2->(FieldPos(SCL->(FieldName(nX))))
					If ( nPosField <> 0 )
						FieldPut(nX,TMP2->(FieldGet(nPosField)))
					EndIf
				Next nX
				cItem := Soma1(cItem)
				SCL->CL_FILIAL := xFilial("SCL")
				SCL->CL_NUM    := M->CJ_NUM
				SCL->CL_ITEM   := cItem
				SCL->CL_NUMOP  := ""
				lGravou := .T.
			EndIf
		EndIf
		cItemAnt := TMP2->CL_ITEMORC
		dbSelectArea("TMP2")
		dbSkip()
		If ( cItemAnt <> TMP2->CL_ITEMORC )
			cItem := "00"
		EndIf
	EndDo
EndIf

If ( nOpcx == 2 ) // Alteracao
	//Ŀ
	// Efetua a Gravacao do Itens                                   
	//
	dbSelectArea("TMP1")
	dbGotop()
	While ( !Eof() )
		dbSelectArea("SCK")
		dbSetOrder(1)
		MsSeek(xFilial("SCK")+M->CJ_NUM+TMP1->CK_ITEM,.F.)
		If (  Found() )
			RecLock("SCK",.F.)
			If ( TMP1->CK_FLAG )
				MaAvalOrc("SCK",2)
				dbDelete()
			EndIf
		Else
			If ( !TMP1->CK_FLAG .And. !Empty(TMP1->CK_PRODUTO) )//.Or.!Empty(TMP1->CK_CLIPROD)) )
				RecLock("SCK",.T.)
			EndIf
		EndIf
		If ( !TMP1->CK_FLAG .And. !Empty(TMP1->CK_PRODUTO) )//.Or.!Empty(TMP1->CK_CLIPROD)) )
			For nX := 1 To FCount()
				nPosField := TMP1->(FieldPos(SCK->(FieldName(nX))))
				If ( nPosField <> 0 )
					FieldPut(nX,TMP1->(FieldGet(nPosField)))
				EndIf
			Next nX
			SCK->CK_FILIAL := xFilial("SCK")
			SCK->CK_NUM    := M->CJ_NUM
			SCK->CK_CLIENTE:= M->CJ_CLIENTE
			SCK->CK_LOJA   := M->CJ_LOJA
			lGravou := .T.
			MaAvalOrc("SCK",1)
		EndIf
		dbSelectArea("TMP1")
		dbSkip()
	EndDo
	//Ŀ
	// Efetua a Gravacao dos Sub-itens TMP2                         
	//
	cItem := "00"
	dbSelectArea("TMP2")
	dbGotop()
	While ( !Eof() )
		dbSelectArea("SCK")
		dbSetOrder(1)
		MsSeek(xFilial()+TMP2->CL_NUM+TMP2->CL_ITEMORC,.F.)
		//Ŀ
		// VerIfico se o SCK nao foi deletado                           
		//
		If ( Found() )
			dbSelectArea("SCL")
			dbSetOrder(1)
			MsSeek(xFilial("SCL")+TMP2->CL_NUM+TMP2->CL_ITEMORC+TMP2->CL_ITEM,.F.)
			If ( Found() )
				RecLock("SCL",.F.)
				If ( TMP2->CL_FLAG )
					dbDelete()
				EndIf
			Else
				If ( !TMP2->CL_FLAG )
					RecLock("SCL",.T.)
				EndIf
			EndIf
			If ( !TMP2->CL_FLAG )
				For nX := 1 To FCount()
					nPosField := TMP2->(FieldPos(SCL->(FieldName(nX))))
					If ( nPosField <> 0 )
						FieldPut(nX,TMP2->(FieldGet(nPosField)))
					EndIf
				Next nX
				cItem := Soma1(cItem)
				SCL->CL_FILIAL := xFilial("SCL")
				SCL->CL_NUM    := M->CJ_NUM
				SCL->CL_ITEM   := cItem  // Refaz itens do SCL
				lGravou := .T.
			EndIf
		Else
			dbSelectArea("SCL")
			dbSetOrder(1)
			MsSeek(xFilial("SCL")+TMP2->CL_NUM+TMP2->CL_ITEMORC,.F.)

			While ( !Eof() .And. SCL->CL_FILIAL  == xFilial("SCL") .And.;
					SCL->CL_NUM     == TMP2->CL_NUM   .And.;
					SCL->CL_ITEMORC == TMP2->CL_ITEMORC )
				RecLock("SCL",.F.)
				dbDelete()
				dbSelectArea("SCL")
				dbSkip()
			EndDo
		EndIf
		//Ŀ
		// Aqui e' controlada a quebra de itens pelo SCK                
		//
		cItemAnt := TMP2->CL_ITEMORC
		dbSelectArea("TMP2")
		dbSkip()
		If ( cItemAnt <> TMP2->CL_ITEMORC )
			cItem := "00"
		EndIf
	EndDo
	//Ŀ
	// Efetua a Gravacao do Cabecario                               
	//
	If ( lGravou )
		dbSelectArea("SCJ")
		RecLock("SCJ",.F.)
		For nX := 1 To FCount()
			If ("FILIAL" $ FieldName(nX) )
				FieldPut(nX,xFilial())
			Else
				FieldPut(nX,M->&(FieldName(nX)))
			EndIf
		Next nX
		cStatus := IIf(Empty(SCJ->CJ_CLIENTE) .Or. Empty(M->CJ_CONDPAG),"D",cStatus)
		MaAvalOrc("SCJ",11)
	Else
		dbSelectArea("SCJ")
		RecLock("SCJ",.F.)
		MaAvalOrc("SCJ",12)
		dbDelete()
	EndIf
EndIf
If ( nOpcx == 3 ) // Exclui
	//Ŀ
	// Deleta os Sub-Itens existentes.                              
	//
	dbSelectArea("SCL")
	dbSetOrder(1)
	MsSeek(xFilial("SCL")+M->CJ_NUM,.T.)
	While ( !Eof() .And. xFilial("SCL") == SCL->CL_FILIAL .And.;
			SCL->CL_NUM == M->CJ_NUM )
		RecLock("SCL")
		dbDelete()
		dbSelectArea("SCL")
		dbSkip()
	EndDo
	//Ŀ
	// Deleta os Itens existentes.                                  
	//
	dbSelectArea("SCK")
	dbSetOrder(1)
	MsSeek(xFilial("SCK")+M->CJ_NUM,.T.)
	While ( !Eof() .And. xFilial("SCK") == SCK->CK_FILIAL .And.;
			SCK->CK_NUM == M->CJ_NUM )
		RecLock("SCK")
		MaAvalOrc("SCK",2)
		dbDelete()
		dbSelectArea("SCK")
		dbSkip()
	EndDo
	//Ŀ
	// Deleta o Cabecario                                           
	//
	dbSelectArea("SCJ")
	RecLock("SCJ")
	dbDelete()
	MaAvalOrc("SCJ",12)
EndIf

Return(lGravou)

/*/


Ŀ
Funo    A000LinOk    Autor                       Data           
Ĵ
Descrio  Validacao da Linha na GetDadosDB                           
Ĵ
Sintaxe    Logical A000LinOk(Void)                                    
Ĵ
Parametros                                                            
Ĵ
 Uso       GIVIA000                                                   
ٱ


/*/
User Function A000LinOk(oGetDb)

Local aArea    := GetArea()
Local aAreaTMP1:= {}
Local aContrato:= {}
Local lRetorno := .T.
Local nValor   := 0
Local nX       := 0
Local nQuant   := 0 
Local cTabEsp  := ""


l415Auto := If(Type("l415Auto")<>"U",l415Auto,.F.)
l416Auto := If(Type("l416Auto")<>"U",l416Auto,.F.)

nRecTMP		:=	Recno("TMP1")
//_aAreaTMP	:=	GetArea("TMP1")

DbSelectArea("TMP1")
DbGoto(nRecTMP)
//RestArea(_aAreaTMP)

//Ŀ
// VerIfica se a linha foi deletada                     
//
If ( !TMP1->CK_FLAG .And. !(Empty(TMP1->CK_PRODUTO) .And. TMP1->CK_ITEM=="01") )
	//Ŀ
	// VerIfica se os campos obrigatorios foram preenchidos 
	//
	If ( lRetorno .And.  Empty(TMP1->CK_PRODUTO)  .Or.;
			Empty(TMP1->CK_TES   )  .Or.;
			Empty(TMP1->CK_LOCAL) )

		HELP(" ",1,"OBRIGAT")
		lRetorno := .F.
	EndIf
	//Ŀ
	// VerIfica se o Valor Total da Linha  valido                  
	//
	If ( lRetorno )
		nValor := (TMP1->CK_QTDVEN * TMP1->CK_PRCVEN)
		nValor := A410Arred(nValor,"CK_VALOR")
		If ( nValor != TMP1->CK_VALOR )
			Help(" ",1,"A415TOTAL")
			lRetorno := .F.
		EndIf
	EndIf
	//Ŀ
	// Verifica se o Valor do desconto  Valido.                    
	//
	If (TMP1->(FieldPos("CK_VALDESC")) > 0 )
		If ( lRetorno .And. IIf(TMP1->CK_VALOR>0,TMP1->CK_VALOR <= 0,.F.) )
			Help(" ",1,"A415DESCON")
			lRetorno := .F.
		EndIf
	EndIf
	//Ŀ
	// Correcao da Classificacao fiscal do Produto.                 
	//
	TMP1->CK_CLASFIS	:=	GetAdvFVal("SB1","B1_ORIGEM",xFilial("SB1")+TMP1->CK_PRODUTO,1,"0")+GetAdvFVal("SF4","F4_SITTRIB",xFilial("SF4")+TMP1->CK_TES,1,"00")

EndIf

If l415Auto .or. l416Auto
	A000Total()
Else
	A000Total(oGetDb:oWnd)
EndIf
RestArea(aArea)
Return(lRetorno)

/*/


Ŀ
Funo    A000TudOk    Autor                       Data           
Ĵ
Descrio  Validacao da GetDadosDB                                    
Ĵ
Sintaxe    Logical A000TudOk(Void)                                    
Ĵ
Parametros                                                            
Ĵ
 Uso       GIVIA000                                                   
ٱ


/*/
User Function A000TudOk(oGetd)

Local aArea    := GetArea()
Local aContrato:= {}
Local lRetorno := .T.
Local nValor   := 0
Local nX       := 0
Local oDlg

l415Auto := If(Type("l415Auto")<>"U",l415Auto,.F.)
l416Auto := If(Type("l416Auto")<>"U",l416Auto,.F.)

If !(l415Auto .or. l416Auto)
	oDlg := oGetd:oWnd
EndIf
dbSelectArea("TMP1")
dbGotop()
While ( !Eof() .And. lRetorno )
	//Ŀ
	// Verifica se a linha foi deletada                     
	//
	If ( !TMP1->CK_FLAG .And. !Empty(TMP1->CK_PRODUTO) )
		//Ŀ
		// Verifica se os campos obrigatorios foram preenchidos  
		//
		If ( lRetorno .And. Empty(TMP1->CK_TES   ) .Or.;
				Empty(TMP1->CK_LOCAL ) )
			HELP(" ",1,"OBRIGAT")
			lRetorno := .F.
		EndIf
		//Ŀ
		// Verifica se o Valor Total da Linha  valido                  
		//
		If ( lRetorno )
			nValor := A410Arred((TMP1->CK_QTDVEN * TMP1->CK_PRCVEN),"CK_VALOR")
			If ( nValor <> TMP1->CK_VALOR )
				Help(" ",1,"A415TOTAL")
				lRetorno := .F.
			EndIf
		EndIf
		//Ŀ
		// VerIfica se o Valor do desconto  Valido.                    
		//
		If (TMP1->(FieldPos("CK_VALDESC")) > 0 )
			If ( lRetorno .And. IIf(TMP1->CK_VALOR>0,TMP1->CK_VALOR <= 0,.F.) )
				Help(" ",1,"A415DESCON")
				lRetorno := .F.
			EndIf
		EndIf
		//Ŀ
		// Verifica o contrato de parceria                              
		//
		If TMP1->(FieldPos("CK_CONTRAT"))<>0 .And. TMP1->(FieldPos("CK_ITEMCON"))<>0 .And. !Empty(TMP1->CK_CONTRAT)
			nX := aScan(aContrato,{|x| x[1] == TMP1->CK_CONTRAT .And. x[2] == TMP1->CK_ITEMCON})
			If nX == 0
				aadd(aContrato,{TMP1->CK_CONTRAT,TMP1->CK_ITEMCON,TMP1->CK_QTDVEN})
				nX := Len(aContrato)
			Else
				aContrato[nX][3] += TMP1->CK_QTDVEN
			EndIf
		EndIf
	EndIf
	//Ŀ
	// Verifica o contrato de parceria                              
	//
	If TMP1->(FieldPos("CK_CONTRAT"))<>0 .And. TMP1->(FieldPos("CK_ITEMCON"))<>0 .And. !Empty(TMP1->CK_PRODUTO)
		dbSelectArea("SCK")
		dbSetOrder(1)
		If MsSeek(xFilial("SCK")+M->CJ_NUM+TMP1->CK_ITEM) .And. !Empty(SCK->CK_CONTRAT)
			nX := aScan(aContrato,{|x| x[1] == SCK->CK_CONTRAT .And. x[2] == SCK->CK_ITEMCON})
			If nX == 0
				aadd(aContrato,{SCK->CK_CONTRAT,SCK->CK_ITEMCON,0})
				nX := Len(aContrato)
			EndIf
			aContrato[nX][3] -= SCK->CK_QTDVEN
		EndIf
	EndIf
	dbSelectArea("TMP1")
	dbSkip()
EndDo
//Ŀ
// Verifica o contrato de parceria                              
//
If lRetorno
	For nX := 1 To Len(aContrato)
		dbSelectArea("ADB")
		dbSetOrder(1)
		MsSeek(xFilial("ADB")+aContrato[nX][1]+aContrato[nX][2])
		If aContrato[nX][3] > ADB->ADB_QUANT-ADB->ADB_QTDEMP
			Help(" ",1,"A410CTRQT2")
			lRetorno := .F.
		EndIf
	Next nX
EndIf
//Ŀ
//Verifica se a tabela de precos eh valida                 
//
If lRetorno
	lRetorno := MaVldTabPrc(M->CJ_TABELA,M->CJ_CONDPAG,Nil,M->CJ_EMISSAO)
EndIf

If lRetorno
	dbSelectArea("SA1")
	dbSetOrder(1)
	If MsSeek(xFilial("SA1")+M->CJ_CLIENTE+M->CJ_LOJA)
		If !RegistroOk("SA1")
			lRetorno	 := .F.
		Endif	
	Endif
Endif	

**************************************************************************

If lRetorno
	//Ŀ
	//Calcula apenas se houver um valor de desconto preenchido 
	//
	If !( Empty(M->CJ_DESC1) .And. Empty(M->CJ_DESC2) .And. ;
			Empty(M->CJ_DESC3) .And. Empty(M->CJ_DESC4) )
		a000DesCab()
	EndIf
	IF 	(M->CJ_TABELA == '001' .AND. M->CJ_DESC1 > 11.00) .OR. ;
		(M->CJ_TABELA == '002' .AND. M->CJ_DESC1 >  9.28) .OR.	;
		(M->CJ_TABELA == '003' .AND. M->CJ_DESC1 >  4.50) 
		Alert("DESCONTO MAIOR QUE O PERMITIDO PARA A TABELA, ALTERANDO PARA O DESCONTO MAXIMO!!")

		Do Case
			Case M->CJ_TABELA == '001'
				M->CJ_DESC1 := 11.00
			Case M->CJ_TABELA == '002'
				M->CJ_DESC1 :=  9.28
			Case M->CJ_TABELA == '003'
				M->CJ_DESC1 :=  4.50
		EndCase					

		a000DesCab()

		lRetorno	:=	.F.

	ENDIF
	a000Total(oDlg)
EndIf                          



RestArea(aArea)
Return(lRetorno)


/*/


Ŀ
Funo    A000Prod     Autor                       Data           
Ĵ
Descrio  Validacao da Digitacao do Produto                          
Ĵ
Sintaxe    Logical A000Prod(Void)                                     
Ĵ
Parametros                                                            
Ĵ
 Uso       GIVIA000                                                   
ٱ


/*/
Static Function A000Prod(cProduto)

Local lRetorno := .T.
Local aArea    := GetArea()
Local cDescri  := ""
Local cAnterior:= ""

cProduto := IIf(cProduto==Nil,M->CK_PRODUTO,cProduto)

//Ŀ
// Posiciona Registros                                  
//
dbSelectArea("SA7")
dbSetOrder(1)
If ( MsSeek(xFilial()+M->CJ_CLIENTE+M->CJ_LOJA+cProduto,.T.) )
	cDescri := SA7->A7_DESCCLI
EndIf

dbSelectArea("SB1")
dbSetOrder(1)
MsSeek(xFilial()+cProduto,.T.)

If ( Found() )        

	//Ŀ
	// Verifica se o produto tem foto, se sim mostra-a      
	//

	IF !EMPTY(SB1->B1_BITMAP)

		DEFINE MSDIALOG oDlgPs TITLE OemToAnsi("Foto") FROM 10,50 TO 300,500 OF GetWndDefault() PIXEL
			@ 000,000 REPOSITORY oBmpS SIZE 150,150 OF oDlgPs NOBORDER PIXEL
			oBmpS:SetColor(GetSysColor(15),GetSysColor(15))
			oBmpS:lStretch := .T.
			oBmpS:lVisible := .T.
		
			ShowBitmap(oBmpS,ALLTRIM(SB1->B1_BITMAP))
		
			DEFINE SBUTTON FROM 114,180	TYPE 1 ENABLE OF oDlgPs ACTION (oDlgPs:End()) 
		
		ACTIVATE MSDIALOG oDlgPs CENTERED

	ENDIF

	//Ŀ
	// Preenche os dados vidos do Produto                   
	//
	dbSelectArea("TMP1")
	If (FieldPos("CK_UM") > 0 )
		TMP1->CK_UM       := SB1->B1_UM
	EndIf
	If (FieldPos("CK_TES") > 0 )
		If (!Empty(SB1->B1_TS))
			TMP1->CK_TES      := SB1->B1_TS
		Else
			TMP1->CK_TES      := A000TesPad()
		EndIf
	EndIf
	If (FieldPos("CK_LOCAL") > 0 )
		TMP1->CK_LOCAL    := SB1->B1_LOCPAD
	EndIf
	If (FieldPos("CK_COMIS1") > 0 )
		TMP1->CK_COMIS1   := SB1->B1_COMIS
	EndIf
	If (FieldPos("CK_DESCRI") > 0 )
		TMP1->CK_DESCRI   := PadL(IIf(Empty(cDescri),SB1->B1_DESC,cDescri),Len(TMP1->CK_DESCRI))
	EndIf
	If (FieldPos("CK_CONTRAT") > 0 )
		TMP1->CK_CONTRAT := ""
	EndIf
	If (FieldPos("CK_ITEMCON") > 0 )
		TMP1->CK_ITEMCON := ""
	EndIf
Else
	lRetorno := .F.
EndIf

//Ŀ
// Qdo e'dIferente apaga os sub-itens.                  
//
If ( lRetorno .And. TMP1->CK_PRODUTO <> cProduto )
	cAnterior := TMP1->CK_PRODUTO
	TMP1->CK_PRODUTO := cProduto
	a000GrvSCL(aHeaderSCL,{})
	TMP1->CK_PRODUTO := cAnterior
EndIf

RestArea(aArea)
Return(lRetorno)


/*/


Ŀ
Funo    A000SCLPrd   Autor                       Data           
Ĵ
Descrio  Validacao da Digitacao do Produto                          
Ĵ
Sintaxe    Void A000SCLPrd(Void)                                      
Ĵ
Parametros                                                            
Ĵ
 Uso       GIVIA000                                                   
ٱ


/*/
Static Function A000SCLPrd()

Local lRetorno := .T.
Local nPosDesc := 0
Local aArea    := GetArea()

dbSelectArea("SBH")
dbSetOrder(1)
MsSeek(xFilial()+M->CL_PRODUTO,.T.)

If ( !Eof() .And. xFilial()==SBH->BH_FILIAL .And.;
		M->CL_PRODUTO == SBH->BH_PRODUTO )
	Help(" ",1,"A415SCLPRD")
	lRetorno := .f.
EndIf

If ( M->CL_PRODUTO == TMP1->CK_PRODUTO )
	lRetorno := .F.
	Help(" ",1,"A415SCLPRD")
Else
	nPosDesc := aScan(aHeader,{|x| Trim(x[2])=="CL_DESCRI" })
	If ( nPosDesc > 0 )
		dbSelectArea("SB1")
		dbSetOrder(1)
		MsSeek(xFilial()+M->CL_PRODUTO,.T.)
		aCols[n,nPosDesc] := SB1->B1_DESC
	EndIf
EndIf
RestArea(aArea)
Return(lRetorno)

/*/


Ŀ
Funo    A000SCLQtd   Autor                       Data           
Ĵ
Descrio  Validacao da Digitacao da Quantidade                       
Ĵ
Sintaxe    Void A000SCLQtd(Void)                                      
Ĵ
Parametros                                                            
Ĵ
 Uso       GIVIA000                                                   
ٱ


/*/
Static Function A000SCLQtd()

Local nPos := 0
nPos := aScan(aHeader,{|x| Trim(x[2]) == "CL_QTDVEN" })
If ( nPos > 0 )
	aCols[n,nPos]  := M->CL_QUANT * TMP1->CK_QTDVEN
EndIf
Return(.T.)

/*/


Ŀ
Funo    A000Descon   Autor                       Data           
Ĵ
Descrio  Validacao da Digitacao do Percentual de Desconto           
Ĵ
Sintaxe    ExpL1 := A000Descon( [ ExpL2 ] )                           
Ĵ
Parametros                                                            
Ĵ
 Uso       GIVIA000                                                   
ٱ


/*/
User Function A000Descon()

Local aArea		:= GetArea()
Local lRetorno	:= .T.
Local nPrUnit	:= TMP1->CK_PRUNIT
Local nPrcVen	:= TMP1->CK_PRCVEN
Local nVlrOrig	:= 0
Local cGetVar	:= ReadVar()
    
If ( TMP1->(FieldPos("CK_VALDESC")) > 0 .And.;
		TMP1->(FieldPos("CK_DESCONT"))>0  .And.;
		TMP1->CK_QTDVEN>0 .And.;
		TMP1->CK_PRCVEN>0 )

	If ( TMP1->(FieldPos("CK_PRUNIT"))==0 .Or. Empty(TMP1->CK_PRUNIT) )
		nPrUnit  := ((TMP1->CK_PRCVEN*TMP1->CK_QTDVEN)+TMP1->CK_VALDESC)/TMP1->CK_QTDVEN
	Else
		nPrUnit := a000PrcDes(TMP1->CK_PRUNIT)
	EndIf
	nVlrOrig := nPrUnit * TMP1->CK_QTDVEN
	nPrcVen   := A410Arred(nPrUnit*( 1 - M->CK_DESCONT/100),"CK_PRCVEN")
	If ( nPrcVen <= 0 )                 
	
		TMP1->CK_DESCONT  := 0
		TMP1->CK_VALDESC  := 0
		Help(" ",1,"A415DESCON")
		lRetorno := .F.
	Else
		TMP1->CK_PRCVEN   := nPrcVen
		TMP1->CK_VALOR    := A410Arred((TMP1->CK_QTDVEN * TMP1->CK_PRCVEN),"CK_VALOR")
		TMP1->CK_VALDESC  := Max(nVlrOrig - TMP1->CK_VALOR,0)
		TMP1->CK_DESCONT  := If(cGetVar<>"M->CK_DESCONT",NoRound(TMP1->CK_VALDESC/nVlrOrig*100,TamSX3("CK_DESCONT")[2]),M->CK_DESCONT)
		M->CK_VALDESC     := TMP1->CK_VALDESC
		M->CK_DESCONT     := If(cGetVar<>"M->CK_DESCONT",TMP1->CK_DESCONT,M->CK_DESCONT)
	EndIf
EndIf
RestArea( aArea )
Return(lRetorno)

/*/


Ŀ
Funo    A000VlDesc   Autor                       Data           
Ĵ
Descrio  Validacao da Digitacao do Valor de Desconto                
Ĵ
Sintaxe    Logical A000VlDesc(Void)                                   
Ĵ
Parametros                                                            
Ĵ
 Uso       GIVIA000                                                   
ٱ


/*/
Static Function A000VlDesc()

Local lRetorno    := .T.
Local nValor      := 0
Local nPerc       := 0
Local aArea       := GetArea()
Local nVlrDesc    := 0
Local nDIfDesc := 0

If ( TMP1->(FieldPos("CK_VALDESC")) > 0 .And.;
		TMP1->(FieldPos("CK_DESCONT")) > 0 )
	nValor   := M->CK_VALDESC
	nPerc       := TMP1->CK_DESCONT
	If ( nValor >= TMP1->CK_VALOR )
		Help(" ",1,"A415DESCON")
		lRetorno := .F.
	Else
		nVlrDesc := TMP1->CK_VALDESC
		nDIfDesc := TMP1->CK_VALOR + nVlrDesc - nValor
		TMP1->CK_VALDESC  := nValor
		TMP1->CK_PRCVEN   := A410Arred((TMP1->CK_VALOR + nVlrDesc - nValor)/TMP1->CK_QTDVEN,"CK_PRCVEN")
		TMP1->CK_VALOR    := A410Arred((TMP1->CK_QTDVEN * TMP1->CK_PRCVEN),"CK_VALOR")
		TMP1->CK_VALDESC  += (nDIfDesc - TMP1->CK_VALOR)
		M->CK_VALDESC     := TMP1->CK_VALDESC
		nValor            := TMP1->CK_VALDESC
		nPerc             := NoRound(TMP1->CK_VALDESC/(TMP1->CK_VALOR+nValor)*100,TamSX3("CK_DESCONT")[2])
		TMP1->CK_DESCONT  := nPerc		
	EndIf
EndIf
RestArea( aArea )
Return(lRetorno)

/*/


Ŀ
Funo    A000QtdVen   Autor                       Data           
Ĵ
Descrio  Validacao da Digitacao da Quantidade.                      
Ĵ
Sintaxe    Logical A000QtdVen(Void)                                   
Ĵ
Parametros                                                            
Ĵ
 Uso       GIVIA000                                                   
ٱ


/*/
User Function A000QtdVen()

Local aArea    := GetArea()
Local aAreaTMP1:= {}
Local aContrato:= {}
Local lRetorno := .T.
Local nQtdVen  := M->CK_QTDVEN
Local nPrVend	 := TMP1->CK_PRCVEN
Local nPrUnit	 := TMP1->CK_PRUNIT
Local nValor   := TMP1->CK_VALOR
Local nX       := 0
Private CK_DESCONT := 0
l415Auto := If(Type("l415Auto")<>"U",l415Auto,.F.)
l416Auto := If(Type("l416Auto")<>"U",l416Auto,.F.)
If lRetorno
	//Ŀ
	// Atualiza Valor Total                                 
	//
	TMP1->CK_QTDVEN   := M->CK_QTDVEN // Forca a gravacao para usar as funcoes internas
	TMP1->CK_PRUNIT   := nPrUnit // Preco de tabela
	TMP1->CK_PRCVEN		:= nPrVend // Preco de Venda
	TMP1->CK_VALOR    := A410Arred(TMP1->CK_QTDVEN * TMP1->CK_PRCVEN,"CK_VALOR")

//    ALERT(TMP1->CK_PRUNIT)
	//Ŀ
	// Atualiza Desconto pelo percentual                    
	//
	If (  TMP1->(FieldPos("CK_PRUNIT")) > 0 .And.;
			TMP1->(FieldPos("CK_DESCONT")) > 0 .And.;
			TMP1->(FieldPos("CK_VALDESC")) > 0)
		M->CK_DESCONT := 0 // Para compatibilizar com A000Descon
		lRetorno := u_a000Descon()
	EndIf
//    ALERT(TMP1->CK_PRUNIT)                                    
//    ALERT(nPrUnit)
//    ALERT(nPrVend)
	If ( !lRetorno )
		TMP1->CK_VALOR    := nValor
		TMP1->CK_QTDVEN   := nQtdVen
	EndIf
	If ( lRetorno )
		TMP1->CK_QTDVEN 	:= M->CK_QTDVEN
		TMP1->CK_PRCVEN		:= nPrVend
		TMP1->CK_PRUNIT		:= nPrUnit
		TMP1->CK_VALOR 		:= A410Arred(TMP1->CK_QTDVEN * nPrVend,"CK_VALOR")
	EndIf
//    ALERT(TMP1->CK_PRUNIT)                                    
//    ALERT(nPrUnit)
//    ALERT(nPrVend)
EndIf
RestArea(aArea)
Return(lRetorno)

/*/


Ŀ
Funo    A000PrcVen   Autor                       Data           
Ĵ
Descrio  Validacao da Digitacao do Preco de Venda.                  
Ĵ
Sintaxe    Void A000PrcVen(Void)                                      
Ĵ
Parametros                                                            
Ĵ
 Uso       GIVIA000                                                   
ٱ


/*/
User Function A000PrcVen()

Local lRetorno  := .T.
Local nAnterior:= 0
Private CK_DESCONT := 0
//Ŀ
// Atualiza Valor Total                                 
//
TMP1->CK_VALOR := a410Arred(TMP1->CK_QTDVEN * M->CK_PRCVEN,"CK_VALOR")
//Ŀ
// Atualiza Desconto pelo percentual                    
//
If (  TMP1->(FieldPos("CK_PRUNIT")) > 0 .And.;
		TMP1->(FieldPos("CK_DESCONT")) > 0 .And.;
		TMP1->(FieldPos("CK_VALDESC")) > 0)
	nAnterior       := M->CK_PRCVEN // Para compatibilizar com A000Descon
	TMP1->CK_PRCVEN := M->CK_PRCVEN // Para compatibilizar com A000Descon
	If TMP1->CK_DESCONT > 0
		TMP1->CK_DESCONT := 0  // Para compatibilizar com A000Descon
		TMP1->CK_VALDESC := 0
	EndIf
EndIf
Return(lRetorno)

/*/


Ŀ
Funo    A000CliPad   Autor                       Data           
Ĵ
Descrio  Inicializacao do Cliente Padrao                            
Ĵ
Sintaxe    Void A000CliPad(Void)                                      
Ĵ
Parametros                                                            
Ĵ
 Uso       GIVIA000                                                   
ٱ


/*/
Static Function A000CliPad()

Local aArea        := GetArea()
Local cCliente     := GetMv("MV_ORCLIPD")
Local aAreaSX3     := {}   // Armazena a Area do SX3
Local cA1Tipo      := "R"  // Valor Padrao do Campo A1_TIPO
Local cCodCli      := ""
Local cLojCli      := ""

cCodCli := Left( cCliente, Len( SA1->A1_COD ) ) 
cLojCli := Right( cCliente, Len( SA1->A1_LOJA ) )      

If !Empty( cCodCli ) .And. !Empty( cLojCli )

	dbSelectArea("SA1")
	dbSetOrder(1)
	MsSeek(xFilial()+cCliente)
	
	If ( !Found() )
	
		Reclock("SA1",.T.)
		SA1->A1_FILIAL    := xFilial("SA1")
		SA1->A1_COD       := Substr(cCliente,1,Len(SA1->A1_COD))
		SA1->A1_TIPO      := cA1Tipo
		SA1->A1_LOJA      := Substr(cCliente,1+Len(SA1->A1_COD),Len(SA1->A1_LOJA))
		SA1->A1_NOME      := "CLIENTE PADRAO P/ ORCAMENTO"
		SA1->A1_NREDUZ    := "PED_REPRE"
		SA1->A1_MUN       := "."
		SA1->A1_EST       := GetMv("MV_ESTADO")
		SA1->A1_BAIRRO    := "."
		SA1->A1_END       := "."
	
	EndIf
	RestArea(aArea)
EndIf	
	
Return(cCliente)

/*/


Ŀ
Funo    A000CondPad  Autor                       Data           
Ĵ
Descrio  Inicializacao do Cliente Padrao                            
Ĵ
Sintaxe    Void A000CondPad(Void)                                     
Ĵ
Parametros                                                            
Ĵ
 Uso       GIVIA000                                                   
ٱ


/*/
Static Function A000CondPad()

Local aArea    := GetArea()
Local cCondPag := GetMv("MV_ORCPGPD")

dbSelectArea("SE4")
dbSetOrder(1)
MsSeek(xFilial()+cCondPag)
If ( !Found() )
	Reclock("SE4",.T.)
	SE4->E4_FILIAL   := xFilial()
	SE4->E4_CODIGO   := cCondPag
	SE4->E4_TIPO     := "1"
	SE4->E4_COND     := "0"
	SE4->E4_DESCRI   := "ORCAMENTO"
	MsUnlock()
EndIf
RestArea(aArea)
Return(cCondPag)

/*/


Ŀ
Funo    A000TesPad   Autor                       Data           
Ĵ
Descrio  Inicializacao do Tes Padrao                                
Ĵ
Sintaxe    Void A000TesPad(Void)                                      
Ĵ
Parametros                                                            
Ĵ
 Uso       GIVIA000                                                   
ٱ


/*/
Static Function A000TesPad()

Local aArea    := GetArea()
Local cTes     := GetMv("MV_TESSAI")

dbSelectArea("SF4")
dbSetOrder(1)
MsSeek(xFilial()+cTes)
If ( !Found() )
	cTes := Space(3)
EndIf
RestArea(aArea)
Return(cTes)

/*/


Ŀ
Funcao    A000Tabela  Autor                         Data          
Ĵ
Descrio Calculo da Tabela de Preco                                  
Ĵ
ParametrosExpC1: Codigo do Produto                                    
          ExpC2: Codigo da Tabela                                     
          ExpN3: Quantidade                                           
Ĵ
Retorno   ExpN1: Preco do produto                                     
                                                                      
Ĵ
Descrio Esta rotina tem como objetivo retornar a preco de venda     
          do produto                                                  
                                                                      
Ĵ
Observacao  Usado nos campos C6_PRODUTO e C6_QTDVEN                   
                                                                      
Ĵ
Uso        GIVIA000                                                   
ٱ


/*/
User Function A000Tabela(cProduto,cTabprec,nQtde)

Local aArea     := GetArea()
Local aAreaSB1  := SB1->(GetArea())
Local aAreaADA  := ADA->(GetArea())
Local aAreaADB  := ADB->(GetArea())
Local aAreaTMP1 := {}
Local aContrato := {}
Local nX        := 0
Local nPrcVen   := 0
Local cOpcional := ""
Local cOpc      := ""
Local cCliente  := M->CJ_CLIENTE
Local cLoja     := M->CJ_LOJA
Local cAliasADA := "ADA"
Local cAliasADB := "ADB"
Local lQuery    := .F.
Local lValido   := .T.
Local lContrat  := SuperGetMV("MV_PRCCTR")

DEFAULT nQtde   := 0

//Ŀ
// Verifica se ha contrato de parceria                  
//
If nPrcVen == 0
	dbSelectArea("SB1")
	dbSetOrder(1)
	If ( !Empty(cProduto) .And. dbSeek(xFilial("SB1")+cProduto,.F.) )
		nPrcVen := U_Ma000TabPrV(cTabPrec,cProduto,nQtde,cCliente,cLoja,M->CJ_MOEDA,M->CJ_EMISSAO)
	EndIf
EndIf
RestArea(aAreaADA)
RestArea(aAreaADB)
RestArea(aAreaSB1)
RestArea(aArea)
Return (nPrcVen)

/*/


Ŀ
Funcao    MATABPRVEN  Autor                         Data          
Ĵ
Descrio Funcao para trazer preco de venda de acordo com a qtde      
Ĵ
Retorno   ExpN1: Numerico (Preco de Venda)                            
Ĵ
ParametrosExpC1: Tabela de Preco                                      
          ExpC2: Codigo do Produto                                    
          ExpN3: Quantidade                                           
          ExpC4: Cliente                                              
          ExpC5: Loja                                                 
          ExpN6: Moeda a ser retornada                                
          ExpN7: Tipo                                                 
                 1 = Preco (Default)                                  
                 2 = Fator de acrescimo ou desconto                   
Ĵ
   DATA    Programador   Manutencao Efetuada                         
Ĵ
                                                                     
ٱ


/*/
User Function Ma000TabPrV(cTabPreco,cProduto,nQtde,cCliente,cLoja,nMoeda,dDataVld,nTipo)

Static cMvEstado
Static cMvNorte

Local aArea     := GetArea()
Local aAreaSB1  := SB1->(GetArea())
Local aStruDA1  := {}

Local cTpOper   := ""
Local cQuery    := ""
Local cAliasDA1 := "DA1"

Local nPrcVen   := 0
Local nResult   := 0
Local nMoedaTab := 1
Local nScan     := 0
Local nY        := 0
Local cMascara  := SuperGetMv("MV_MASCGRD")      
Local nTamProd  := Len(SB1->B1_COD)
Local nFator    := 0

Local lUltResult:= .T.
Local lQuery    := .F.
Local lProcessa := .F.
Local lGrade    := MaGrade()
Local lGradeReal:= .F.
Local lPrcDA1   := .F.

DEFAULT cMvEstado := GetMv("MV_ESTADO")
DEFAULT cMvNorte  := GetMv("MV_NORTE")
DEFAULT nMoeda    := 1
DEFAULT dDataVld  := dDataBase
DEFAULT nTipo     := 1

If lGrade .And.	MatGrdPrrf(@cProduto)
	nTamProd := Val(Substr(cMascara,1,2))
	lGradeReal:= .T.	
Endif

	If !(Empty(cCliente) .And. nQtde == 0 )
		//Ŀ
		//Acho o tipo de operacao para busca do preco de venda
		//
		dbSelectArea("SA1")
		dbSetOrder(1)
		If MsSeek(xFilial("SA1")+cCliente+cLoja)
			Do Case
				Case SA1->A1_EST == cMvEstado
					cTpOper := "1"
				Case SA1->A1_EST != cMvEstado
					If (SA1->A1_EST $ cMvNorte) .And. !(cMvEstado $ cMvNorte)
						cTpOper := "3"
					Else
						cTpOper := "2"
					EndIf						
			EndCase					
		EndIf												
	Endif	

	dbSelectarea("DA1")
	dbSetOrder(1)

	#IFDEF TOP
		If TcSrvType() <> "AS/400"
			lQuery    := .T.
			cAliasDA1 := "QRYDA1"
			aStruDA1  := DA1->(dbStruct())
			
			cQuery := "SELECT * "
			cQuery += "FROM "+RetSqlName("DA1")+ " DA1 "
			cQuery += "WHERE "
			cQuery += "DA1_FILIAL = '"+xFilial("DA1")+"' AND "
			cQuery += "DA1_CODTAB = '"+cTabPreco+"' AND "

			If lGradeReal
				cQuery += "DA1_CODPRO LIKE '"+cProduto+"%' AND "
			Else 
				cQuery += "DA1_CODPRO = '"+cProduto+"' AND "			
			Endif	                                 

			cQuery += "DA1_QTDLOT >= "+Str(nQtde,18,8)+" AND "
			cQuery += "DA1_ATIVO = '1' AND  "			
			
    		cQuery += "( DA1_DATVIG <= '"+DtoS(dDataVld)+ "' OR DA1_DATVIG = '"+Dtos(Ctod("//"))+ "' ) AND "
			
			If !(nQtde == 0 .And. Empty(cCliente))
				cQuery += "( DA1_TPOPER = '"+cTpOper+"' OR DA1_TPOPER = '4' ) AND "
			Endif                     
			
			cQuery += "DA1.D_E_L_E_T_ = ' ' "
			cQuery += "ORDER BY "+SqlOrder(DA1->(IndexKey()))
			
			cQuery := ChangeQuery(cQuery)
			
			dbUseArea(.T.,"TOPCONN",TcGenQry(,,cQuery),cAliasDA1,.T.,.T.)
			
			For nY := 1 To Len(aStruDA1)
				If aStruDA1[nY][2]<>"C"
					TcSetField(cAliasDA1,aStruDA1[nY][1],aStruDA1[nY][2],aStruDA1[nY][3],aStruDA1[nY][4])
				EndIf
			Next nY

			If (cAliasDA1)->(!Eof())
				lProcessa := .T.
			Endif				
		
		Else
	#ENDIF
			dbSelectarea("DA1")
			dbSetOrder(1)
			If MsSeek(xFilial("DA1")+ cTabPreco + cProduto)   
				lProcessa := .T.
			Endif				
			
	#IFDEF TOP
		Endif
	#ENDIF
							
   	If lProcessa
	
			If nQtde == 0 .And. Empty(cCliente)
				nPrcVen   := (cAliasDA1)->DA1_PRCVEN
				nMoedaTab := (cAliasDA1)->DA1_MOEDA
				nFator    := (cAliasDA1)->DA1_PERDES
				
				lPrcDA1   := .T.
			Else
				//Ŀ
				//Busco o preco e analiso a qtde de acordo com a faixa
				//
				dbSelectArea(cAliasDA1)
				While (cAliasDA1)->(!Eof()) .And. (cAliasDA1)->DA1_FILIAL == xFilial("DA1") .And.;
									(cAliasDA1)->DA1_CODTAB == cTabPreco .And.;
									Left((cAliasDA1)->DA1_CODPRO,nTamProd) ==  cProduto
	
					If nQtde <= (cAliasDA1)->DA1_QTDLOT .And. (cAliasDA1)->DA1_ATIVO == "1"
					
						If Empty((cAliasDA1)->DA1_ESTADO) .And. ((cAliasDA1)->DA1_TPOPER == cTpOper .Or. (cAliasDA1)->DA1_TPOPER == "4")				
						
							//Ŀ
							//Verifica a vigencia do item                                   
							//
							
							nQtdLote := (cAliasDA1)->DA1_QTDLOT
							
							While (cAliasDA1)->(!Eof()) .And. (cAliasDA1)->DA1_FILIAL == xFilial("DA1") .And.;
																(cAliasDA1)->DA1_CODTAB == cTabPreco .And.;
																Left((cAliasDA1)->DA1_CODPRO,nTamProd) ==  cProduto .And.;
																(cAliasDA1)->DA1_QTDLOT == nQtdLote .And.;
																(cAliasDA1)->DA1_DATVIG <= dDataVld .And. !lPrcDA1
								If nQtde <= (cAliasDA1)->DA1_QTDLOT															
									
									nPrcVen   := (cAliasDA1)->DA1_PRCVEN
									nMoedaTab := (cAliasDA1)->DA1_MOEDA 
									nFator    := (cAliasDA1)->DA1_PERDES
	
									lPrcDA1   := .T.
									Exit
	       						Endif
												
								dbSelectArea(cAliasDA1)
								dbSkip()
					        Enddo
	
						ElseIf !Empty((cAliasDA1)->DA1_ESTADO) .And. ( SA1->A1_EST == (cAliasDA1)->DA1_ESTADO )
						
							//Ŀ
							//Verifica a vigencia do item                                   
							//
							
							nQtdLote := (cAliasDA1)->DA1_QTDLOT
							
							While (cAliasDA1)->(!Eof()) .And. (cAliasDA1)->DA1_FILIAL == xFilial("DA1") .And.;
																	(cAliasDA1)->DA1_CODTAB == cTabPreco .And.;
																	Left((cAliasDA1)->DA1_CODPRO,nTamProd) ==  cProduto .And.;
																	(cAliasDA1)->DA1_QTDLOT == nQtdLote .And.;																
																	(cAliasDA1)->DA1_DATVIG <= dDataVld 
								If nQtde <= (cAliasDA1)->DA1_QTDLOT
		
									nPrcVen   := (cAliasDA1)->DA1_PRCVEN
									nMoedaTab := (cAliasDA1)->DA1_MOEDA
									nFator    := (cAliasDA1)->DA1_PERDES
		
									lPrcDA1   := .T.
									
									Exit
								Endif									
									
								dbSelectArea(cAliasDA1)
								dbSkip()
					        Enddo
	
							If lPrcDA1
								Exit
							Endif	 
							
						EndIf									
					EndIf						
					dbSelectArea(cAliasDA1)
					dbSkip()
				Enddo	     
	
				//Ŀ
				//Somente atualiza com o SB1 caso nao tenha achado nenhuma tabela    
				//caso contrario retornara o preco zerado                            			
				//
			                                  
				If nTipo == 1
					If nPrcVen == 0 .And. !lPrcDA1
						dbSelectArea("SB1")
						dbSetOrder(1)
						If MsSeek(xFilial("SB1")+cProduto)
							nPrcVen := SB1->B1_PRV1
						EndIf
						lUltResult := .F.
					Endif				
				Endif
				
			EndIf
	Else                     
		If nTipo == 1	
			dbSelectArea("SB1")
			dbSetOrder(1)
			If MsSeek(xFilial("SB1")+cProduto)
				nPrcVen := SB1->B1_PRV1
			EndIf
		Endif	
		lUltResult := .F.
	EndIf

	//Ŀ
	//Se o tipo for para trazer preco converte para a moeda    
	//

	nFator := Iif( nFator == 0, 1, nFator )	
	
	If nTipo == 1
		nResult := xMoeda(nPrcVen,nMoedaTab,nMoeda,,TamSx3("D2_PRCVEN")[2])
	Else 
		nResult	:= nFator
	Endif
		
If lQuery
	dbSelectArea(cAliasDA1)
	dbCloseArea()
	dbSelectArea("DA1")
Endif	

RestArea(aAreaSB1)
RestArea(aArea)
Return(nResult)


/*/

Ŀ
Funo    A000GeraCL Autor                         Data           
Ĵ
Descrio  Programa de Preenchimento da aCols                         
                                                                      
Ĵ
Sintaxe e  aCols A000GeraCL(Void)                                     
Ĵ
Parametros                                                            
Ĵ
Uso        GIVIA000                                                   
ٱ


/*/
Static Function A000GeraCL()

Local aArea		:= GetArea()
Local aHeader  := {}
Local aCols    := {}
Local nUsado	:= 0
Local nX	:= 0
Local nAcols	:= 0
Local nPos		:= 0
Local nPos2		:= 0
Local nPosItem  := 0
Local nItem		:= 0

//Ŀ
// Monta aCols                                                  
//
aHeader := aHeaderSCL
nUsado  := Len(aHeader)
nPosItem:= aScan(aHeader,{|x| Trim(x[2]) == "CL_ITEM" })
//Ŀ
// VerIfico se existe no temporario registros validos           
//
dbSelectArea("TMP2") // SCL
dbSetOrder(1)
MsSeek(M->CJ_NUM+TMP1->CK_ITEM,.T.)
While  ( !Eof() .And. M->CJ_NUM+TMP1->CK_ITEM==TMP2->CL_NUM+TMP2->CL_ITEMORC )
	aadd( aCols , Array(nUsado+1) )
	nACols := Len(aCols)
	For nX := 1 To Len(aHeader)
		If ( aHeader[nX][10] <> "V")
			aCols[nAcols][nX] := FieldGet(FieldPos(aHeader[nX][2]))
		Else
			aCols[nAcols][nX] := CriaVar(aHeader[nX][2],.T.)
		EndIf
	Next nX
	aCols[nAcols,nUsado+1] := TMP2->CL_FLAG
	dbSelectArea("TMP2")
	dbSkip()
EndDo
//Ŀ
// VerIfico se o Produto e'uma sugestao de venda e se o acols   
// esta vazia                                                   
//
If ( Empty(aCols) )
	nItem := 0
	dbSelectArea("SBH")
	dbSetOrder(1)
	MsSeek(xFilial()+TMP1->CK_PRODUTO,.T.)
	While  ( !Eof() .And. xFilial()==SBH->BH_FILIAL .And. ;
			SBH->BH_PRODUTO == TMP1->CK_PRODUTO )
		aadd( aCols , Array(nUsado+1) )
		nACols := Len(aCols)
		nPos   := 0
		For nX := 1 To Len(aHeader)
			Do Case
			Case Trim(aHeader[nX,2])=="CL_PRODUTO"
				aCols[nACols,nX] := SBH->BH_CODCOMP
				If ( nPos > 0 )
					dbSelectArea("SB1")
					dbSetOrder(1)
					MsSeek(xFilial()+aCols[nAcols,nX])
					aCols[nAcols,nPos] := PadL(SB1->B1_DESC,TamSX3("CL_DESCRI")[1])
				EndIf
				nPos := nX
			Case Trim(aHeader[nX,2])=="CL_QUANT"
				aCols[nACols,nX] := SBH->BH_QUANT
			Case Trim(aHeader[nX,2])=="CL_DESCRI"
				If ( nPos > 0 )
					dbSelectArea("SB1")
					dbSetOrder(1)
					MsSeek(xFilial()+aCols[nAcols,nPos])
					aCols[nAcols,nX] := PadL(SB1->B1_DESC,TamSX3("CL_DESCRI")[1])
				EndIf
				nPos := nX
			OtherWise
				aCols[nAcols][nX] := CriaVar(aHeader[nX][2],.T.)
			EndCase
		Next nX
		aCols[nAcols,nPosItem] := StrZero(++nItem,2)
		aCols[nAcols,nUsado+1] := .F.
		dbSelectArea("SBH")
		dbSkip()
	EndDo
EndIf
//Ŀ
// Se no existir registros validos e'criada uma aCols vazia    
//
If ( Empty(aCols) )
	aadd( aCols , Array(nUsado+1) )
	nACols := Len(aCols)
	For nX := 1 To nUsado
		aCols[nAcols][nX] := CriaVar(aHeader[nX][2],.T.)
	Next nX
	aCols[nAcols,nUsado+1] := .F.
	aCols[nAcols,nPosItem] := "01"
EndIf
//Ŀ
// Inicializa o a Qtd Necessaria para o orcamento               
//
nPos := aScan(aHeader,{|x| Trim(x[2]) == "CL_QTDVEN" })
nPos2:= aScan(aHeader,{|x| Trim(x[2]) == "CL_QUANT" })
nACols := Len(aCols)
If ( nPos > 0 .And. nPos2 > 0 )
	For nX := 1 To nACols
		aCols[nX,nPos]  := aCols[nX,nPos2] * TMP1->CK_QTDVEN
	Next
EndIf
RestArea(aArea)
Return(aCols)

/*/

Ŀ
Funo    A000GrvSCL Autor                         Data           
Ĵ
Descrio  Programa de Atualizacao do Arquivo Temporario referente ao 
           SCL                                                        
Ĵ
Sintaxe e  Void A000GrvSCL(aHeader,aCols)                             
Ĵ
Parametros aHeader e Acols                                            
Ĵ
Uso        GIVIA000                                                   
ٱ


/*/
Static Function A000GrvSCL(aHeader,aCols)

Local nX  := 0
Local nX2 := 0
Local nUsado  := nAcols   := 0
Local nProduto:= aScan(aHeader,{|x| Trim(x[2])=="CL_PRODUTO" })
Local aArea   := GetArea()

dbSelectArea("TMP2")
dbSetOrder(1)
MsSeek(M->CJ_NUM+TMP1->CK_ITEM,.T.)
While  ( !Eof() .And. M->CJ_NUM+TMP1->CK_ITEM==TMP2->CL_NUM+TMP2->CL_ITEMORC )
	RecLock("TMP2")
	dbDelete()
	MsUnlock()
	dbSelectArea("TMP2")
	dbSkip()
EndDo
nAcols := Len(aCols)
For nX := 1 To nAcols
	If ( nProduto > 0 )
		If ( !Empty(aCols[nX,nProduto]) )
			nUsado := Len(aHeader)
			RecLock("TMP2",.T.)
			For nX2 := 1 To nUsado
				nPosField := FieldPos(Trim(aHeader[nX2,2]))
				If ( nPosField > 0 )
					FieldPut(nPosField,aCols[nX,nX2])
				EndIf
			Next nX2
			TMP2->CL_NUM      := M->CJ_NUM
			TMP2->CL_ITEMORC  := TMP1->CK_ITEM
			TMP2->CL_FLAG     := aCols[nX,nUsado+1]
			MsUnlock()
		EndIf
	EndIf
Next nX
RestArea(aArea)
Return(.T.)

/*/

Ŀ
Funo    A000PrcLis Autor                         Data           
Ĵ
Descrio  Programa de Calculo do Preco de Lista                      
Ĵ
Sintaxe e  Void A000PrcLis(Void)                                      
Ĵ
Parametros                                                            
Ĵ
Uso        GIVIA000                                                   
ٱ


/*/
Static Function A000PrcLista()

Local aArea		:= GetArea()
Local nPrcLista := 0

dbSelectArea("TMP2")
dbSetOrder(1)
MsSeek(M->CJ_NUM+TMP1->CK_ITEM,.T.)

While ( !Eof() .And. M->CJ_NUM == TMP2->CL_NUM .And. ;
		TMP2->CL_ITEMORC == TMP1->CK_ITEM )

	dbSelectArea("SB1")
	dbSetOrder(1)
	MsSeek(xFilial()+TMP2->CL_PRODUTO)

	If ( !TMP2->CL_FLAG )

		nPrcLista += (TMP2->CL_QUANT*u_a000Tabela(TMP2->CL_PRODUTO,M->CJ_TABELA,TMP1->CK_QTDVEN*TMP2->CL_QUANT))

	EndIf

	dbSelectArea("TMP2")
	dbSkip()
EndDo

RestArea(aArea)
Return(nPrcLista)

/*/


Ŀ
Funo    A000Total    Autor                       Data           
Ĵ
Descrio  Totalizacao do orcamento                                   
Ĵ
Sintaxe   Void A000Total(Void)                                        
Ĵ
Parametros oDlg: Objeto Windows                                       
Ĵ
 Uso       GIVIA000                                                   
ٱ


/*/
Static Function A000Total(oDlg)

Local aArea   	:= GetArea()
Local aAreaTmp1	:= TMP1->(GetArea())
Local nTotVal 	:= 0
Local nTotDesc	:= 0
Local nPerDesc  := M->CJ_DESC4
Local nX  := 0
Local aControl

l415Auto := If(Type("l415Auto")<>"U",l415Auto,.F.)
l416Auto := If(Type("l416Auto")<>"U",l416Auto,.F.)

If !(l415Auto) .and. !(l416Auto)
	aControl := oDlg:aControls
EndIf
//Ŀ
//Soma o os valores e os descontos, mostrando-os na tela
//
dbSelectArea("TMP1")
dbGotop()
While ( !Eof() )
	If ( !TMP1->CK_FLAG )
		nTotVal  += TMP1->CK_VALOR
		If (TMP1->CK_PRUNIT > TMP1->CK_PRCVEN)
			nTotDesc += A410Arred((TMP1->CK_PRUNIT * TMP1->CK_QTDVEN),"CK_VALOR") - A410Arred((TMP1->CK_PRCVEN * TMP1->CK_QTDVEN),"CK_VALOR")
		Else
			nTotDesc += TMP1->CK_VALDESC
		EndIf
	EndIf
	dbSelectArea("TMP1")
	dbSkip()
EndDo
nTotDesc += M->CJ_DESCONT
nTotVal  -= M->CJ_DESCONT
nTotDesc += A410Arred(nTotVal*M->CJ_PDESCAB/100,"C6_VALOR")
nTotVal  -= A410Arred(nTotVal*M->CJ_PDESCAB/100,"C6_VALOR")
//Ŀ
//Calcula o Desconto por Total                          
//
If nTotVal > 0 .And. FtRegraDesc(4,nTotVal+nTotDesc,@M->CJ_DESC4) <> nPerDesc
	//Ŀ
	//Soma o os valores e os descontos, mostrando-os na tela
	//
	nTotVal := 0
	nTotDesc:= 0
	dbSelectArea("TMP1")
	dbGotop()
	While ( !Eof() )
		If ( !TMP1->CK_FLAG )
			nTotVal  += TMP1->CK_VALOR
			If (TMP1->CK_PRUNIT > TMP1->CK_PRCVEN)
				nTotDesc += A410Arred((TMP1->CK_PRUNIT * TMP1->CK_QTDVEN),"CK_VALOR") - A410Arred((TMP1->CK_PRCVEN * TMP1->CK_QTDVEN),"CK_VALOR")
			Else
				nTotDesc += TMP1->CK_VALDESC
			EndIf
		EndIf
		dbSelectArea("TMP1")
		dbSkip()
	EndDo
EndIf
If !( l415Auto .or. l416Auto)
	For nX := 1 To Len(aControl)
		If ( ValType(aControl[nX]:Cargo)=="C")
			Do Case
			Case ( aControl[nX]:Cargo $ "Total" )
				aControl[nX]:SetText(nTotVal)
			Case ( aControl[nX]:Cargo $ "Desconto" )
				aControl[nX]:SetText(nTotDesc)
			Case ( aControl[nX]:Cargo $ "Valor" )
				aControl[nX]:SetText(nTotVal+nTotDesc)
			EndCase
		EndIf
	Next nX
EndIf
RestArea(aAreaTmp1)
RestArea(aArea)
Return(Nil)

/*/


Ŀ
Funcao    A000DesCab Autor                         Data           
Ĵ
Descrio Recalculo automatico do desconto de cabecalho sobre o preco 
          de lista.                                                   
Ĵ
Retorno   Sempre .T.                                                  
Ĵ
ParametrosExpL1 : Default (.T.)                                       
          ExpL2 : Recalcular ( .T. )                                  
Ĵ
   DATA    Programador   Manutencao Efetuada                         
Ĵ
                                                                     
ٱ


/*/

Static Function a000DesCab(lTodos,lRecal,lRecItens)

Local aArea		:= GetArea()
Local aAreaTmp1:= TMP1->(GetArea())
Local nPrcVen   := 0

DEFAULT lTodos	:= .T.
DEFAULT lRecal  := .T.
DEFAULT lRecItens  := .F.

dbSelectArea("TMP1")
If ( lTodos )
	dbGotop()
EndIf
While ( !Eof() )
	nPrcVen := TMP1->CK_PRUNIT
	If ( nPrcVen > 0.00 )

		//Ŀ
		//Deve re-calcular o desconto dos items para pegar o desconto escalavel, 
		//que eh por item, mais calculado no total.                              
		//
		If lRecItens	
			TMP1->CK_DESCONT	:=	FtRegraDesc(2)
		Endif	
		nPrcVen := a000PrcDes(nPrcVen)
		nPrcVen := (nPrcVen*(1-TMP1->CK_DESCONT/100))
		nPrcVen := a410Arred(nPrcVen,"CK_PRCVEN")
		TMP1->CK_PRCVEN := nPrcVen
		TMP1->CK_VALOR  := A410Arred(TMP1->CK_QTDVEN * TMP1->CK_PRCVEN,"CK_VALOR")
		TMP1->CK_VALDESC:= (a000PrcDes(TMP1->CK_PRUNIT)-nPrcVen)*TMP1->CK_QTDVEN
		TMP1->CK_DESCONT:= NoRound((1-(nPrcVen/a000PrcDes(TMP1->CK_PRUNIT)))*100,TamSx3("CK_DESCONT")[2])
	EndIf
	If ( lTodos )
		dbSelectArea("TMP1")
		dbSkip()
	Else
		Exit
	EndIf
EndDo
If lRecal
	If (Type("l415Auto") == "L" .and. l415Auto) .or. (Type("l416Auto") == "L" .and. l416Auto)
		A000Total()
	Else
		A000Total(GetWndDefault())
	EndIf
EndIf
RestArea(aAreaTmp1)
RestArea( aArea )
Return(.T.)

/*/


Ŀ
Funcao    A000PrcDes Autor                         Data           
Ĵ
Descrio Calculo do Preco de Venda com desconto de cabecalho sobre o 
          preco de Lista.                                             
Ĵ
Retorno   ExpN1: Valor com desconto de cabecalho                      
Ĵ
ParametrosExpN1: Preco de Lista                                       
                                                                      
Ĵ
   DATA    Programador   Manutencao Efetuada                         
Ĵ
                                                                     
ٱ


/*/
Static Function A000PrcDes(nPrcLista)

If ( M->CJ_DESC1 > 0 )
	nPrcLista *= (( 100 - M->CJ_DESC1 )/100)
EndIf
If ( M->CJ_DESC2 > 0 )
	nPrcLista *= (( 100 - M->CJ_DESC2 )/100)
EndIf
If ( M->CJ_DESC3 > 0 )
	nPrcLista *= (( 100 - M->CJ_DESC3 )/100)
EndIf
If ( M->CJ_DESC4 > 0 )
	nPrcLista *= (( 100 - M->CJ_DESC4 )/100)
EndIf
Return(nPrcLista)

/*/


Ŀ
Funcao    Ma000Bar   Autor                         Data           
Ĵ
Descrio  EnchoiceBar especIfica do GIVIA000                         
Ĵ
Retorno    Nenhum                                                     
Ĵ
Parametros Nenhum                                                     
Ĵ
Retorno    ExpC1 -> Tabela alterada - p/ gatilho                      
Ĵ
Parametros ExpO1: Objeto Dialog                                       
           ExpB2: Code Block para o Evento Ok                         
           ExpB3: Code Block para o Evento Cancel                     
           ExpN4: nOpc transmitido pela mbrowse                       
Ĵ
   DATA    Programador   Manutencao Efetuada                         
Ĵ
                                                                     
ٱ


/*/
Static Function Ma000Bar(oDlg,bOk,bCancel,nOpc)

Local aUsButtons:= {}
Local aButtons 	:= {}

/*
aadd(aButtons,{"POSCLI"		,{|| If(!Empty(M->CJ_CLIENTE),a450F4Con(),.F.)}	,OemToAnsi("Posio de Cliente")	,OemToAnsi("Clientes") })
aadd(aButtons,{"RELATORIO"	,{|| Ma415Impos()}									,OemToAnsi("Planilha Financeira")	,OemToAnsi("Planilha") })
*/

Return (EnchoiceBar(oDlg,bOK,bcancel,,aButtons))


/*


Ŀ
Funo    A000TabAlt   Autor                       Data           
Ĵ
Descrio  Funcao de Alteracao da tabela de precos.                   
Ĵ
Sintaxe    ExpC1 := A000TabAlt()                                      
Ĵ
Parametros Nenhum                                                     
Ĵ
Retorno    ExpC1 -> Tabela alterada - p/ gatilho                      
Ĵ
 Uso       GIVIA000                                                   
ٱ


*/
Static Function A000TabAlt()

Local aArea      := GetArea()
Local aAreaSB1   := SB1->(GetArea())

LOCAL nRegAtu    := 0
LOCAL nPrcVen    := 0
LOCAL nVlrTabela := 0

LOCAL lPrcOrc    := GetMv("MV_PRCORC")

nRegAtu := TMP1->( RecNo() )

//Ŀ
// Atualiza os valores dos itens com base na tabela     
//
TMP1->( dbGoTop() )
While TMP1->( !Eof() )

	If lPrcOrc

		dbSelectArea("TMP2")
		dbSetOrder(1)
		If MsSeek(M->CJ_NUM+TMP1->CK_ITEM,.T.)

			nPrcVen := 0

			While ( !Eof() .And. M->CJ_NUM == TMP2->CL_NUM .And. ;
					TMP2->CL_ITEMORC == TMP1->CK_ITEM )

				dbSelectArea("SB1")
				dbSetOrder(1)
				MsSeek(xFilial()+TMP2->CL_PRODUTO)

				If ( !TMP2->CL_FLAG )
					nPrcVen += (TMP2->CL_QUANT*U_A000Tabela(TMP2->CL_PRODUTO,M->CJ_TABELA,TMP2->CL_QUANT*TMP1->CK_QTDVEN))
				EndIf

				dbSelectArea("TMP2")
				dbSkip()
			EndDo
		Else
			nPrcVen := U_A000Tabela(TMP1->CK_PRODUTO,M->CJ_TABELA,TMP1->CK_QTDVEN)
		Endif	

	Else
		nPrcVen := U_A000Tabela(TMP1->CK_PRODUTO,M->CJ_TABELA,TMP1->CK_QTDVEN)
	Endif	    	

	nVlrTabela := nPrcVen

	RecLock("TMP1",.F.)	
	TMP1->CK_PRUNIT  := nVlrTabela
	TMP1->CK_PRCVEN  := nPrcVen
	TMP1->CK_VALOR   := A410Arred(TMP1->CK_QTDVEN*TMP1->CK_PRCVEN,"CK_VALOR")
	MsUnlock()

	TMP1->(dbSkip())

EndDo

//Ŀ
// Aplica os descontos de cabecalho e de item           
//
A000DesCab( .T. )

//Ŀ
// Posiciona na linha original                          
//
TMP1->( MsGoto( nRegAtu ) )

If Type("oGetDad") <> "U"
	oGetDad:oBrowse:Refresh()
Endif	

RestArea(aAreaSB1)
RestArea(aArea)

Return( M->CJ_TABELA )

/*


Ŀ
Funo    A000TabCli   Autor                       Data           
Ĵ
Descrio  Alteracao da tabela de precos com base na tabela do cliente
Ĵ
Sintaxe    ExpC1 := A000TabCli()                                      
Ĵ
Parametros Nenhum                                                     
Ĵ
Retorno    ExpC1 -> Tabela do cliente                                 
Ĵ
 Uso       GIVIA000                                                   
ٱ


*/

Static Function A000TabCli()

LOCAL cTabCli

cTabCli      := SA1->A1_TABELA
M->CJ_TABELA := cTabCli

//Ŀ
// Atualiza os valores com base na nova tabela 
//
A000TabAlt()

Return( cTabCli )


/*/


Ŀ
Funo    MaCanDelOrc  Autor                       Data           
Ĵ
Descrio Verifica se Orcamento de Venda pode ser Deletado.           
Ĵ
Sintaxe    ExpC1 := MaCanDelOrc()                                     
Ĵ
Parametros ExpC1: Alias do SCJ                                        
           ExpC2: Alias do SCK                                        
Ĵ
Retorno    ExpL1 -> Indica se o item de Orcamento pode ser deletado   
Ĵ
Observacao O SCJ deve estar posicionado e a funcao deve ser processada
           item a item do SCK.                                        
Ĵ
 Uso       GIVIA000                                                   
ٱ


/*/
Static Function MaCanDelOrc(cAliasSCJ,cAliasSCK)

Local lRetorno := .T.
If ( (cAliasSCJ)->CJ_STATUS == "B" )
	lRetorno := .F.
Else
	If ( cAliasSCK <> Nil )
		lRetorno := Empty((cAliasSCK)->CK_NUMOP)
	EndIf
EndIf
Return(lRetorno)
/*/


Ŀ
Funo    MaAvalOrc    Autor                       Data           
Ĵ
Descrio Rotina de avaliacao dos eventos de um orcamento             
Ĵ
Sintaxe    ExpC1 := MaCanDelOrc()                                     
Ĵ
Parametros ExpC1: Alias do SCJ ou SCK                                 
           ExpN2: Evento que deve ser avaliado                        
                  [01] Implantacao do item do Orcamento de Venda (SCK)
                  [02] Estorno do item do Orcamento de Venda (SCK)    
                  [03] Baixa do item do Orcamento de Venda (SCK)      
                  [04] Cancelamento do Orcamento de venda ( SCK )     
                  [11] Implantacao de um orcamento de venda ( SCJ )   
                  [12] Estorno de um orcamento de venda ( SCJ )       
                  [13] Baixa do Orcamento de venda                    
                  [14] Cancelamento do Orcamento de venda             
Ĵ
Retorno    ExpL1 -> Indica se o item de Orcamento pode ser deletado   
Ĵ
Observacao O SCJ deve estar posicionado, pois sobre atualizacao, o SCK
          nao sofre atualizacao mas deve estar posicionado tb.        
Ĵ
 Uso       GIVIA000                                                   
ٱ


/*/
Static Function MaAvalOrc(cAlias,nEvento)

Local aArea := GetArea()
Static cStatus
DEFAULT cStatus := "E"
Do Case
Case nEvento == 01
	//Ŀ
	//Atualiza os dados Complementares             
	//
	cStatus := IIf((cAlias)->CK_ITEM=="01","E",cStatus)
	If ( (cAlias)->CK_VALOR == 0 )
		cStatus := "D" //Nao Orcado
	EndIf
Case nEvento == 02
	//Ŀ
	//Atualiza os dados Complementares             
	//
Case nEvento == 03
	//Ŀ
	//Atualiza os dados Complementares             
	//
	cStatus := "B" //Baixado
Case nEvento == 04
	//Ŀ
	//Atualiza os dados Complementares             
	//
Case nEvento == 11
	//Ŀ
	//Atualiza os dados Complementares             
	//
	cStatus := IIf(Empty((cAlias)->CJ_CLIENTE) .Or. Empty((cAlias)->CJ_CONDPAG),"D",cStatus)
	(cAlias)->CJ_STATUS := cStatus
Case nEvento == 12
	//Ŀ
	//Atualiza os dados Complementares             
	//
Case nEvento == 13
	//Ŀ
	//Atualiza os dados Complementares             
	//
	(cAlias)->CJ_STATUS := cStatus
Case nEvento == 14
	//Ŀ
	//Atualiza os dados Complementares             
	//
	cStatus := "C"
	(cAlias)->CJ_STATUS := cStatus
EndCase
RestArea(aArea)
Return(.T.)
/*/


Ŀ
Funo    Ma000Auto    Autor                       Data           
Ĵ
Descrio Rotina de avaliacao do cancelamento dos Orcamentos por      
          vencimento de validade.                                     
Ĵ
Sintaxe    ExpC1 := Ma000Auto()                                       
Ĵ
Parametros Nenhum                                                     
Ĵ
Retorno    Nenhum                                                     
Ĵ
ObservacaoEsta rotina efetua o cancelamento automatico dos orcamento  
          apos o vencimento da validade do mesmo.                     
Ĵ
 Uso       GIVIA000                                                   
ٱ


/*/
Static Function Ma000Auto()

Local aArea      	:= GetArea()
Local lEnd       	:= .F.
Local lContinua 	:= GetMv("MV_ORCVLD") .And. __cInterNet <> "AUTOMATICO"
If ( lContinua )
	If ( GetMv("MV_ORCUVLD") >= dDataBase )
		lContinua := .F.
	EndIf
	GetMv("MV_ORCVLD")
	dbSelectArea("SX6")
	lContinua := MsRLock()
	If ( lContinua )
		Processa({|lEnd| Ma000PAuto(@lEnd)},"Cancelamento de Orcamentos vencidos",OemToAnsi("Cancelando orcamentos..."),.F.)
		dbSelectArea("SX6")
		GetMv("MV_ORCVLD")
		MsRUnLock()
	EndIf
EndIf
RestArea(aArea)
Return(.T.)

/*/


Ŀ
Funo    Ma000PAuto   Autor                       Data           
Ĵ
Descrio Rotina de avaliacao do cancelamento dos Orcamentos por      
          vencimento de validade (Processamento)                      
Ĵ
Sintaxe    ExpC1 := Ma000Auto()                                       
Ĵ
Parametros Nenhum                                                     
Ĵ
Retorno    Nenhum                                                     
Ĵ
ObservacaoEsta rotina efetua o cancelamento automatico dos orcamento  
          apos o vencimento da validade do mesmo.                     
Ĵ
 Uso       GIVIA000                                                   
ٱ


/*/
Static Function Ma000PAuto(lEnd)

Local aArea     := GetArea()
Local aAreaSCJ  := SCJ->(GetArea())
Local aAreaSCK  := SCK->(GetArea())
Local aStruSCK
Local cAlias    := "SCJ"
Local cAliasSCK := ""
Local cQuery    := ""
Local lQuery    := .T.
Local nX        := 0
ProcRegua(LastRec())
//Ŀ
//Atualiza a data de ultima checagem                      
//
GetMv("MV_ORCUVLD")
dbSelectArea("SX6")
If ( Found() )
	PutMv("MV_ORCUVLD",Dtos(dDataBase))
EndIf
//Ŀ
//Pesquisa os Orcamentos em aberto                        
//
#IFDEF TOP
	If ( TcSrvType()<>"AS/400" )
		lQuery := .T.
		cQuery := "MA415PAUTO"
		cQuery := "SELECT CJ_FILIAL,CJ_NUM,R_E_C_N_O_ SCJRECNO "
		cQuery += "FROM "+RetSqlName("SCJ")+" SCJ "
		cQuery += "SCJ.CJ_FILIAL='"+xFilial("SCJ")+"' AND "
		cQuery += "SCJ.CJ_VALIDA<'"+Dtos(dDataBase)+"' AND "
		cQuery += "SCJ.CJ_STATUS NOT IN('B','C') AND "
		cQuery += "SCJ.D_E_L_E_T_=' '"
		cQuery := ChangeQuery(cQuery)
		dbUseArea(.T.,"TOPCONN",TcGenQry(,,cQuery),cAlias,.T.,.T.)
	Else
#ENDIF	
	dbSelectArea("SCJ")
	dbSetOrder(1)
	dbSeek(xFilial("SCJ"))
	#IFDEF TOP
	EndIf
	#ENDIF	
While ( !Eof() .And. xFilial("SCJ") == (cAlias)->CJ_FILIAL )
	If ( dDataBase > (cAlias)->CJ_VALIDA .And. (cAlias)->CJ_STATUS<>"B#C" )
		If ( lQuery )
			SCJ->(MsGoto((cAlias)->SCJRECNO))
		EndIf
		Begin Transaction
			dbSelectArea("SCK")
			dbSetOrder(1)
			If ( lQuery )
				DEFAULT aStruSCK  := SCK->(dbStruct())
				cAliasSCK := "MA415PAUTO2"
				cQuery := "SELECT * "
				cQuery += "FROM "+RetSqlName("SCK")+" SCK "
				cQuery += "SCK.CK_FILIAL='"+xFilial("SCK")+" AND "
				cQuery += "SCK.CK_NUM='"+SCJ->CJ_NUM+"' AND "
				cQuery += "SCK.D_E_L_E_T=' ' "
				cQuery += "ORDER BY "+SqlOrder(SCJ->(IndexKey()))
				cQuery := ChangeQuery(cQuery)
				dbUseArea(.T.,"TOPCONN",TcGenQry(,,cQuery),cAliasSCK,.T.,.T.)
				For nX := 1 To Len(aStruSCK)
					If ( aStruSCK[nX][2] <> "C" )
						TcSetField(cAlias,aStruSCK[nX][1],aStruSCK[nX][2],aStruSCK[nX][3],aStruSCK[nX][4])
					EndIf
				Next nX
			Else
				MsSeek(xFilial("SCK")+SCJ->CJ_NUM)
			EndIf
			While ( !Eof() .And. (cAliasSCK)->CK_FILIAL==xFilial("SCK") .And. ;
					(cAliasSCK)==SCJ->CJ_NUM )
				MaAvalOrc(cAliasSCK,4)
				dbSelectArea(cAliasSCK)
				dbSkip()
			EndDo
			If ( lQuery )
				dbSelectArea(cAliasSCK)
				dbCloseArea()
				dbSelectArea("SCK")
			EndIf
			MaAvalOrc("SCJ",14)
		End Transaction
	EndIf
	dbSelectArea(cAlias)
	dbSkip()
	If lEnd
		Exit
	EndIf
EndDo
If ( lQuery )
	dbSelectArea(cAlias)
	dbCloseArea()
	dbSelectArea("SCJ")
EndIf
RestArea(aAreaSCJ)
RestArea(aAreaSCK)
RestArea(aArea)
Return(.T.)

/*/


Ŀ
Funo    A000VldTOk   Autor                       Data           
Ĵ
Descrio Rotina de validacao da tudoOk da Enchoice                   
                                                                      
Ĵ
Parametros Nenhum                                                     
Ĵ
Retorno    ExpL1: Dados validos?                                      
Ĵ
ObservacaoEsta rotina efetua a validacao da TudoOk da Enchoice        
Ĵ
 Uso       GIVIA000                                                   
ٱ


/*/
User Function A000VldTOk()

Local lRet      := .T.
Local aProdDesc := {}
Local aAreaTMP  := TMP1->( GetArea() ) 

TMP1->( dbGoTop() )
While TMP1->( !Eof() )

	//Ŀ
	// Inclui os produtos para validacao                      
	//

	nDescon  := 0
	
	cProduto := TMP1->CK_PRODUTO
	cItem    := TMP1->CK_ITEM
	nDescon  := (100 - (TMP1->CK_PRCVEN / TMP1->CK_PRUNIT) * 100 )

	//Ŀ
	// Inclui apenas se nao existir                           
	//       Estrutura do array aProdDesc                                          			
	//       [1] - Codigo do Produto                                               
	//       [2] - Item do Pedido de Venda                                         
	//       [3] - Preco de Venda                                                  
	//       [4] - Preco de Lista                                                  						
	//       [5] - % do Desconto Concedido no item do pedido                       
	//       [6] - % do Desconto Permitido pela regra (FtRegraNeg)                 
	//       [7] - Indica se sera necessario verificar o saldo de verba            
	//                             01 - Bloqueio de regra de negocio               
	//                             02 - Bloqueio para verificacao de verba         
	//       [8] - Valor a ser abatido da verba caso seja aprovada (FtVerbaVen)    			
	//       [9] - Flag que indica se o item sera analisado nas regras             							
	//
	AAdd( aProdDesc, {cProduto,cItem,TMP1->CK_PRCVEN,TMP1->CK_PRUNIT,nDescon,0,"",0,.T.} )
	
	TMP1->(dbSkip())
	
Enddo
                                        
RestArea( aAreaTMP )

//Ŀ
// Verifica Regra e nao analisa verba (ultimo parametro .F.     
//
lRet := FtRegraNeg(M->CJ_CLIENTE,M->CJ_LOJA,M->CJ_TABELA,M->CJ_CONDPAG,,@aProdDesc, .T., .F. )

Return( lRet )                


/*/


Ŀ
Funcao    A000Bonus  Autor                         Data           
Ĵ
Descrio Rotina de tratamento da regra de bonificacao para interface 
                                                                      
Ĵ
ParametrosExpN1: Tipo de operacao                                     
                 [1] Inclusao do bonus                                
                 [2] Exclusao do bonus                                
Ĵ
Retorno   Nenhum                                                      
                                                                      
Ĵ
Descrio Esta rotina tem como objetivo avaliar a regra de bonificacao
          e adicionar na respectiva interface                         
                                                                      
Ĵ
Observacao                                                            
                                                                      
Ĵ
Uso        Materiais/Distribuicao/Logistica                           
ٱ


/*/
Static Function A000Bonus(nTipo)

Local aArea     := GetArea()
Local aBonus    := {}
Local nX        := 0
Local nY        := 0
Local nZ        := 0
Local nW		:= 0
Local cItem     := ""
//Ŀ
//Verifica os bonus                                       
//
If nTipo == 1
	//Ŀ
	//Verifica os bonus por item de venda                     
	//
	aBonus   := FtRgrBonus("TMP1",{"CK_PRODUTO","CK_QTDVEN","CK_TES"},M->CJ_CLIENTE,M->CJ_LOJA,M->CJ_TABELA,M->CJ_CONDPAG)
	//Ŀ
	//Recupera os bonus ja existentes                         
	//	
	aBonus   := FtRecBonus("TMP1",{"CK_PRODUTO","CK_QTDVEN","CK_TES","CK_FLAG"},aBonus)
	//Ŀ
	//Grava os novos bonus                                    
	//		
	nY := Len(aBonus)
	If nY > 0
		nZ := TMP1->(RecNo())
		TMP1->(dbGoBottom())
		cItem := TMP1->CK_ITEM
		TMP1->(dbGoto(nZ))
		For nX := 1 To nY
			cItem := Soma1(cItem)
			RecLock("TMP1",.T.)
			For nW := 1 To Len(aHeader)
				FieldPut(nW,CriaVar(aHeader[nW,2],.T.))
			Next nW
			TMP1->CK_ITEM    := cItem
			TMP1->CK_PRODUTO := aBonus[nX][1]
			A000Prod(TMP1->CK_PRODUTO)
			TMP1->CK_QTDVEN  := aBonus[nX][2]
			TMP1->CK_TES     := aBonus[nX][3]
			If ( TMP1->CK_PRCVEN == 0 )
				TMP1->CK_PRCVEN := 1
				TMP1->CK_VALOR  := TMP1->CK_QTDVEN
			Else
				TMP1->CK_VALOR := A410Arred(TMP1->CK_QTDVEN*TMP1->CK_PRCVEN,"CK_VALOR")
			EndIf
			MsUnLock()
		Next nX
	EndIf
Else
	FtDelBonus("TMP1",{"CK_PRODUTO","CK_QTDVEN","CK_TES","CK_FLAG"})	
EndIf
RestArea(aArea)
Return(.T.)

/*/


Ŀ
Funo    MA000VldFl   Autor                       Data           
Ĵ
Descrio Rotina de validacao das filiais de entrega/Venda            
                                                                      
Ĵ
Parametros Nenhum                                                     
Ĵ
Retorno    ExpL1: Dados validos?                                      
Ĵ
ObservacaoEsta rotina efetua a validacao das filiais de entrega/Venda 
Ĵ
 Uso       GIVIA000                                                   
ٱ


/*/
Static Function Ma000VldFl()

Local lRetorno := .F.

lRetorno := Empty(xFilial("SCJ")+xFilial("SF4")+xFilial("SB1")+xFilial("SE4"))
lRetorno := lRetorno .And. Empty(xFilial("DA0")+xFilial("SBM"))

Return(lRetorno)

/*

Ŀ
Funo    A000LegendAutor                          Data            
Ĵ
          Demonstra a legenda das cores da mbrowse                     
                                                                       
Ĵ
ParametrosNenhum                                                       
                                                                       
Ĵ
Retorno   Nenhum                                                       
                                                                       
Ĵ
Descrio Esta rotina monta uma dialog com a descricao das cores da    
          Mbrowse.                                                     
                                                                       
                                                                       
Ĵ
Uso        Materiais                                                   
ٱ


*/
User Function A000Legend()

Local aCores := {	{ 'ENABLE'		, 'Pedido Liberado'			},; //'Orcamento em Aberto'
					{ 'DISABLE'		, 'Pedido Processado'	 	},; //'Orcamento Baixado'
					{ 'BR_PRETO'	, 'Pedido Cancelado' 		},; //'Orcamento Cancelado' 	
					{ 'BR_AZUL'		, 'Pedido em Elaboracao'	},; //'Orcamento nao Orcado'
					{ 'BR_AMARELO'	, 'Pedido em Aprovacao'		}}
					
BrwLegenda(cCadastro,"Pedidos de Vendas - Representantes",aCores )
	
Return(.T.)

/*
Local aCores := {	{ 'SCJ->CJ_STATUS=="A"' , 'BR_AMARELO'	},;	
					{ 'SCJ->CJ_STATUS=="B"' , 'DISABLE'		},;	
					{ 'SCJ->CJ_STATUS=="C"' , 'BR_PRETO'	},;	
					{ 'SCJ->CJ_STATUS=="D"' , 'BR_AZUL'		}}	
//					{ 'SCJ->CJ_STATUS=="E"' , 'ENABLE' 		}}  
*/



/*/


Ŀ
Funo     A000IMPR  Autor                         Data           
Ĵ
Descrio  Emissao do Pedido de Vendas                                
Ĵ
 Uso       Generico                                                   
Ĵ
 ATUALIZACOES SOFRIDAS DESDE A CONSTRUCAO INICIAL.                     
Ĵ
 PROGRAMADOR   DATA    BOPS   MOTIVO DA ALTERACAO                   
Ĵ
                                                                     
ٱ


/*/
User Function A000IMPR()

LOCAL wnrel		:= "ORCIRC"
LOCAL cDesc1	:= "Emissao dos pedidos de Vendas - Representantes."
LOCAL cDesc2	:= " "
LOCAL cDesc3	:= " "
LOCAL cString	:= "SCJ"

PRIVATE Tamanho		:= "M"
PRIVATE titulo	 	:= "Emissao dos Pedidos de Vendas - Representantes"
PRIVATE aReturn 	:= {"Zebrado", 1,"Administracao", 1, 2, 1, "",0 }
PRIVATE nomeprog	:="ORCIRC"
PRIVATE nLastKey	:= 0
PRIVATE nBegin		:= 0
PRIVATE nDifColCC   := 0
PRIVATE aLinha		:= {}
PRIVATE aSenhas		:= {}
PRIVATE aUsuarios	:= {}
PRIVATE M_PAG		:= 1
PRIVATE nTotIpi		:= 0
PRIVATE nTotIcms	:= 0
PRIVATE nTotalNF	:= 0
PRIVATE nItem       := 0 

If Type("lPedido") != "L"
	lPedido := .F.
Endif

wnrel:=SetPrint(cString,wnrel,,@Titulo,cDesc1,cDesc2,cDesc3,.F.,,,Tamanho,,)

If nLastKey == 27
	Set Filter To
	Return
Endif

SetDefault(aReturn,cString)

If nLastKey == 27
	Set Filter to
	Return
Endif

RptStatus({|lEnd| C110PV(@lEnd,wnRel,cString)},titulo)

Return .T.

/*/


Ŀ
Funo     C110PV    Autor  Cristina M. Ogura      Data  09.11.95 
Ĵ
Descrio  Chamada do Relatorio                                       
Ĵ
 Uso       MATR110			                                          
ٱ


/*/
Static Function C110PV(lEnd,WnRel,cString)
Local nReem
Local nOrder
Local cCondBus
Local nSavRec
Local aSavRec := {}
Local nLinObs := 0 
Local i       := 0
Local ncw     := 0 
Local Transp  := SCJ->CJ_TRANSP
Local Redesp  := SCJ->CJ_REDESP

Private cCGCPict, cCepPict
//Ŀ
//Definir as pictures                                           
//
cCepPict:=PesqPict("SA1","A1_CEP")
cCGCPict:=PesqPict("SA1","A1_CGC")

limite   := 130

li       := 80
nDescProd:= 0
nTotal   := 0
nTotMerc := 0
NumPed   := Space(6)
 
dbSelectArea("SCJ")
SetRegua(RecCount())

//Ŀ
// Faz manualmente porque nao chama a funcao Cabec()                 
//
@ 0,0 PSay AvalImp(Iif(nDifColCC > 0,132,132))            

nDifColCC	:= 12

//Ŀ
// Cria as variaveis para armazenar os valores do pedido        
//
nOrdem   := 1

cObs01   := " "
cObs02   := " "
cObs03   := " "
cObs04   := " "

ImpCabec(ncw)

nTotal   := 0
nTotMerc := 0
cMenNota := ""
nDescProd:= 0
nSavRec  := SCJ->(Recno())
NumPed   := SCJ->CJ_NUM
nLinObs  := 0

DbSelectArea("SCK")
DbSetOrder(1)
DbSeek(xFilial("SCK")+NumPed,.T.)

***********************************************************

While !Eof() .AND. SCK->CK_NUM == SCJ->CJ_NUM 

	If lEnd
		@PROW()+1,001 PSAY "CANCELADO PELO OPERADOR"
		Goto Bottom
		Exit
	Endif
	
	IncRegua()
	
	//Ŀ
	// Verifica se havera salto de formulario                       
	//
	If li > 56
		nOrdem++
		ImpRodape()			// Imprime rodape do formulario e salta para a proxima folha
		ImpCabec(ncw)
	Endif

	@ li,001 PSAY "|"
	@ li,002 PSAY SCK->CK_ITEM  	Picture PesqPict("SCK","CK_ITEM")
	@ li,005 PSAY "|"
	@ li,006 PSAY SCK->CK_PRODUTO	Picture "@!"

	//Ŀ
	// Pesquisa Descricao do Produto                                
	//
	ImpProd()

	//Ŀ
	// Inicializacao da Observacao do Pedido.                       
	//
	If !EMPTY(cMenNota) .And. nLinObs < 5
                nLinObs++
		cVar:="cObs"+StrZero(nLinObs,2)
		Eval(MemVarBlock(cVar),cMenNota)
	Endif

	SCK->(dbSkip())
	li++	
EndDo

//		dbGoto(nSavRec)

If li>38
	nOrdem++
	ImpRodape()		// Imprime rodape do formulario e salta para a proxima folha
	ImpCabec(ncw)
Endif
li--
DbSelectArea("SCJ") 

FinalPed(nDescProd,"",TRANSP,REDESP)		// Imprime os dados complementares do PC

aSavRec := {}

if aReturn[5] == 3
	Eject
Endif
//Ŀ
// Se em disco, desvia para Spool                               
//
If aReturn[5] == 1    // Se Saida para disco, ativa SPOOL
	Set Printer TO
	dbCommitAll()
	ourspool(wnrel)
Endif

MS_FLUSH()

Return .T.

/*/


Ŀ
Funo     ImpProd   Autor  Wagner Xavier          Data           
Ĵ
Descrio  Pesquisar e imprimir  dados Cadastrais do Produto.         
Ĵ
Sintaxe    ImpProd(Void)                                              
Ĵ
 Uso       MatR110                                                    
ٱ


/*/
Static Function ImpProd()
LOCAL nBegin	:= 0
LOCAL cDescri	:= ""
LOCAL nLinha	:=0
LOCAL nTamDesc	:= 28
LOCAL aColuna	:= Array(8)

DbSelectArea("SB1")
DbSetOrder(1)
DbSeek( xFilial()+SCK->CK_PRODUTO)

cIPI	:= SB1->B1_IPI
cDescri := Alltrim(SB1->B1_DESC)

aColuna[1] :=  51
aColuna[2] :=  54
aColuna[3] :=  67
aColuna[4] :=  82
aColuna[5] :=  88
aColuna[6] := 105
aColuna[7] := 116
acoluna[8] := 144 - nDifColCC

nLinha:= MLCount(cDescri,nTamDesc)

@ li,022 PSAY "|"
@ li,023 PSAY MemoLine(cDescri,nTamDesc,1)

ImpCampos(cIPI)

For nBegin := 2 To nLinha
	li++
	@ li,001 PSAY "|"
	@ li,005 PSAY "|"
	@ li,022 PSAY "|"
	@ li,023 PSAY Memoline(cDescri,nTamDesc,nBegin)
	@ li,aColuna[1] PSAY "|"
	@ li,acoluna[2] PSAY "|"  
	@ li,acoluna[3] PSAY "|"  
    @ li,aColuna[4] PSAY "|"
   	@ li,aColuna[5] PSAY "|"
	@ li,aColuna[6] PSAY "|"
	@ li,116 PSAY "|"
//	@ li,137 - nDIfColCC PSAY "|"
	@ li,aColuna[8] PSAY "|"
Next nBegin

Return NIL

/*/


Ŀ
Funo     ImpCampos Autor  Wagner Xavier          Data           
Ĵ
Descrio  Imprimir dados Complementares do Produto no Pedido.        
Ĵ
Sintaxe    ImpCampos(Void)                                            
Ĵ
 Uso       MatR110                                                    
ٱ


/*/
Static Function ImpCampos(cIPI)

LOCAL aColuna[6]                          

	aColuna[1] :=  51
	aColuna[2] :=  54
	aColuna[3] :=  67
	aColuna[4] :=  82
	aColuna[5] :=  88
	aColuna[6] := 105

MaFisAdd(	SCK->CK_PRODUTO					,; 		  // 1-Codigo do Produto ( Obrigatorio )
			SCK->CK_TES						,;		  // 2-Codigo do TES ( Opcional )
			SCK->CK_QTDVEN					,;		  // 3-Quantidade ( Obrigatorio )
			SCK->CK_PRCVEN					,;		  // 4-Preco Unitario ( Obrigatorio )
			0								,; 	      // 5-Valor do Desconto ( Opcional )
			""								,;		  // 6-Numero da NF Original ( Devolucao/Benef )
			""								,;	      // 7-Serie da NF Original ( Devolucao/Benef )
			""								,;	      // 8-RecNo da NF Original no arq SD1/SD2
			0								,;		  // 9-Valor do Frete do Item ( Opcional )
			0								,;		  // 10-Valor da Despesa do item ( Opcional )
			0								,;  	  // 11-Valor do Seguro do item ( Opcional )
			0								,;		  // 12-Valor do Frete Autonomo ( Opcional )
			(SCK->CK_PRCVEN*SCK->CK_QTDVEN)	,;		  // 13-Valor da Mercadoria ( Obrigatorio )
			0								,;		  // 14-Valor da Embalagem ( Opiconal )
			0								,;		  // 15-RecNo do SB1
			0								) 		  // 16-RecNo do SF4

nItem++

@ li,aColuna[1] 		PSAY "|"
@ li,	PCOL()  		PSAY SB1->B1_UM		  									Picture PesqPict("SB1","B1_UM")
@ li,aColuna[2] 		PSAY "|"
@ li,	PCOL()			PSAY SCK->CK_QTDVEN										Picture PesqPictQt("CK_QTDVEN",13)
@ li,aColuna[3] 		PSAY "|"                	
@ li,	PCOL()			PSAY SCK->CK_PRCVEN										Picture PesqPict("SCK","CK_PRCVEN",12)
@ li,aColuna[4] 		PSAY "|"
@ li,   PCOL()  		PSAY MaFisRet(nItem,"IT_ALIQIPI")						PICTURE "@E 99.99" 
@ li,aColuna[5] 		PSAY "|"
@ li,   PCOL()  		PSAY (SCK->CK_QTDVEN*SCK->CK_PRCVEN)					Picture PesqPict("SCK","CK_VALOR",16)
@ li,aColuna[6] 		PSAY "|"
@ li,  PCOL()+1 		PSAY SCK->CK_ENTREG										Picture PesqPict("SCK","CK_ENTREG")
@ li,116 				PSAY "|"
@ li,  	PCOL()+3		PSAY MaFisRet(nItem,"IT_VALIPI")						Picture "@E 999,999.99"
@ li,144 - nDifColCC 	PSAY "|"

nTotal		:= nTotal + (SCK->CK_QTDVEN*SCK->CK_PRCVEN)
nTotalNF	:= nTotalNF + (SCK->CK_QTDVEN*SCK->CK_PRCVEN)
nTotIPI		:= Round(nTotIPI + ((SCK->CK_QTDVEN*SCK->CK_PRCVEN)*(cIPI/100)),2)

Return .T.
/*/


Ŀ
Funo     FinalPed  Autor  Wagner Xavier          Data           
Ĵ
Descrio  Imprime os dados complementares do Pedido de Compra        
Ĵ
Sintaxe    FinalPed(Void)                                             
Ĵ
 Uso       MatR110                                                    
ٱ


/*/
Static Function FinalPed(nDescProd,MENPAD,TRANSP,REDESP)

Local nk 		:= 1,nG
Local nX        := 0
Local nQuebra	:= 0
Local nTotDesc	:= nDescProd
Local lNewAlc	:= .F.
Local lLiber 	:= .F.
Local lImpLeg	:= .T.
Local cComprador:=""
LOcal cAlter	:=""
Local cAprov	:=""
Local aColuna   := Array(8), nTotLinhas
Local nDSZFALC	:=	0                   
Local nICMSST	:=	0
Local nTTot		:=	0

MaFisAlt("NF_FRETE"   ,SCJ->CJ_FRETE)
MaFisAlt("NF_BSFRETE" ,SCJ->CJ_FRETE)
MaFisAlt("NF_SEGURO"  ,0)
MaFisAlt("NF_AUTONOMO",0)
MaFisAlt("NF_DESPESA" ,0)

                   
IF !EMPTY(SA1->A1_SUFRAMA) .AND. SA1->A1_CALCSUF $ "IS"

	nDSZFALC:=	-MaFisRet(,"NF_DESCZF")
    IF	SA1->A1_EST $ 'AL/AM/AP/BA/CE/ES/MA/MG/MT/PA/PI/PR/RJ/RS/SC/SP/' .AND. SA1->A1_TIPO $ 'RS' .AND. SA1->A1_GRPTRIB == '001'
	   //	nICMSST	:=	(MaFisRet(,"NF_VALMERC") - MaFisRet(,"NF_DESCZF")) * 1.7883 * 0.17 - MaFisRet(,"NF_DESCZF") 
	   	    nICMSST	:=	(MaFisRet(,"NF_VALMERC") + nDSZFALC) * 1.7883 * 0.17 - (MaFisRet(,"NF_VALMERC")*0.07)//Guilherme 16.04.13
	ELSE
		nICMSST	:=	0
	ENDIF
	//nTTot	:=	MaFisRet(,"NF_VALMERC") - MaFisRet(,"NF_DESCZF") + nICMSST
      nTTot	:=	MaFisRet(,"NF_VALMERC") + nDSZFALC + nICMSST // Guilherme 16.04.13
ELSE

	nDSZFALC:=	0
	nICMSST	:=	MaFisRet(,"NF_VALSOL")
	nTTot	:=	MaFisRet(,"NF_TOTAL")

ENDIF                  


cMensagem:= ""

If !Empty(cMensagem)
	li++
	@ li,001 PSAY "|"
	@ li,002 PSAY Padc(cMensagem,129)
	@ li,144 - nDifColCC PSAY "|"
Endif
li++
@ li,001 PSAY "|"
@ li,002 PSAY Replicate("-",limite)
@ li,144 - nDifColCC PSAY "|"
li++

aColuna[1] :=  51
aColuna[2] :=  54
aColuna[3] :=  67
aColuna[4] :=  82
aColuna[5] :=  88
aColuna[6] := 105
acoluna[7] := 116
aColuna[8] := 144 - nDifColCC 
nTotLinhas :=  39

While li<nTotLinhas
	@ li,001 PSAY "|"
	@ li,005 PSAY "|"
	@ li,022 PSAY "|"
	@ li,022 + nk PSAY "*"
	nk := IIf( nk == 42 , 1 , nk + 1 )
	@ li,aColuna[1] PSAY "|"
	@ li,aColuna[2] PSAY "|"
	@ li,aColuna[3] PSAY "|"
	@ li,aColuna[4] PSAY "|"
	@ li,aColuna[5] PSAY "|"
	@ li,aColuna[6] PSAY "|"
	@ li,116 PSAY "|"
	@ li,aColuna[8] PSAY "|"
	li++
EndDo
@ li,001 PSAY "|"
@ li,002 PSAY Replicate("-",limite)
@ li,144 - nDifColCC PSAY "|"
li++

_aAreaSA4	:= GETAREA("SA4")

DbSelectArea("SA4")
DbSetOrder(1)
DbSeek(xFilial("SA4")+TRANSP)

@ li,001 PSAY "|"
@ li,003 PSAY "TRANSP.: " + SA4->A4_NOME
@ li,055 PSAY " - CIDADE: " + SA4->A4_MUN
@ li,092 PSAY " - " + SA4->A4_EST
@ li,144 - nDifColCC PSAY "|"
li++                                  

DbSelectArea("SA4")
DbSetOrder(1)
DbSeek(xFilial("SA4")+REDESP)

@ li,001 PSAY "|"
@ li,003 PSAY "REDESP.: " + SA4->A4_NOME
@ li,055 PSAY " - CIDADE: " + SA4->A4_MUN
@ li,092 PSAY " - " + SA4->A4_EST
@ li,144 - nDifColCC PSAY "|"
li++                                  


RestArea(_aAreaSA4)

@ li,001 PSAY "|"
@ li,002 PSAY Replicate("-",limite)
@ li,144 - nDifColCC PSAY "|"
li++
@ li,001 PSAY "|"
//Ŀ
// Posiciona o Arquivo de Empresa SM0.                          
//
cAlias := Alias()
dbSelectArea("SA1")
dbSetOrder(1)  
nRegistro := Recno()
dbSeek(xFilial()+SCJ->CJ_CLIENTE)

//Ŀ
// Imprime endereco de cobranca do SA1                          
//

@ li,001 PSAY "|"
@ li,003 PSAY "Local de Cobranca : " + SUBSTR(SA1->A1_ENDCOB,1,30)		//"Local de Cobranca : "
@ li,057 PSAY "-"
@ li,061 PSAY TRIM(SA1->A1_MUNC)
@ li,083 PSAY "-"
@ li,085 PSAY TRIM(SA1->A1_ESTC)
@ li,088 PSAY "-"
@ li,090 PSAY "CEP :"
@ li,096 PSAY Trans(Alltrim(SA1->A1_CEPC),cCepPict)
@ li,144 - nDifColCC PSAY "|"
li++
@ li,001 PSAY "|"
@ li,002 PSAY Replicate("-",limite)
@ li,144 - nDifColCC PSAY "|"

dbSelectArea("SE4")
dbSetOrder(1)
dbSeek(xFilial()+SCJ->CJ_CONDPAG)
dbSelectArea("SC5")
li++
@ li,001 PSAY "|"
@ li,003 PSAY "Condicao de Pagto: "+SubStr(SE4->E4_COND,1,15)		//
@ li,038 PSAY "|Data de Emissao|"
@ li,056 PSAY "Total das Mercadorias : "
@ li,094 PSAY Transform(MaFisRet(,"NF_VALMERC") ,"@E 999,999,999.99")
//@ li,094 PSAY nTotal Picture "@E 999,999,999.99"
@ li,144 - nDifColCC PSAY "|"
li++
@ li,001 PSAY "|"
@ li,003 PSAY SubStr(SE4->E4_DESCRI,1,34)
@ li,038 PSAY "|"
@ li,043 PSAY SCJ->CJ_EMISSAO
@ li,054 PSAY "|"
@ li,056 PSAY "Total do IPI          : "
@ li,094 PSAY Transform(MaFisRet(,"NF_VALIPI")	,"@E 999,999,999.99")
// 			  nTotIPI Picture "@E 999,999,999.99"
@ li,144 - nDifColCC PSAY "|"

li++
@ li,001 PSAY "|"
@ li,002 PSAY Replicate("-",52)
@ li,054 PSAY "|"
@ li,056 PSAY "Total da Subst. Trib. : "
@ li,094 PSAY Transform(nICMSST	,"@E 999,999,999.99")
//@ li,094 PSAY Transform(MaFisRet(,"NF_VALSOL")	,"@E 999,999,999.99")
//			  nTotIPI Picture "@E 999,999,999.99"
@ li,144 - nDifColCC PSAY "|"

li++
@ li,001 PSAY "|"
@ li,003 PSAY "Validade :"             
@ li,020 PSAY SCJ->CJ_VALIDA
@ li,054 PSAY "|"
@ li,056 PSAY "Total do Desc. ZFM/ALC: "                             
@ li,094 PSAY Transform(nDSZFALC	,"@E 999,999,999.99")
//@ li,094 PSAY Transform(MaFisRet(,"NF_DESCZF")	,"@E 999,999,999.99")
//			  nTotIPI Picture "@E 999,999,999.99"
@ li,144 - nDifColCC PSAY "|"

li++
@ li,001 PSAY "|"
@ li,002 PSAY Replicate("-",52)
@ li,054 PSAY "|" 
@ li,056 PSAY "Total do Frete        : "                             
@ li,094 PSAY Transform(MaFisRet(,"NF_FRETE")	,"@E 999,999,999.99")
//@ li,094 PSAY Transform(MaFisRet(,"NF_DESCZF")	,"@E 999,999,999.99")
//			  nTotIPI Picture "@E 999,999,999.99"
@ li,144 - nDifColCC PSAY "|"

li++
@ li,001 PSAY "|"
@ li,054 PSAY "|" 
@ li,091 PSAY Replicate("-",20)
@ li,144 - nDifColCC PSAY "|"


li++
@ li,001 PSAY "|                Aprovacao do Cliente "
@ li,054 PSAY "|" 
@ li,056 PSAY "Total com Impostos    : "
@ li,094 PSAY Transform(nTTot	,"@E 999,999,999.99")
//@ li,094 PSAY Transform(MaFisRet(,"NF_TOTAL")	,"@E 999,999,999.99")
//			  (nTotal+nTotIPI)  Picture "@E 999,999,999.99"
@ li,144 - nDifColCC PSAY "|"
                                            

//  Finalizar o orcamento aqui.
li++
@ li,001 PSAY "|"
@ li,054 PSAY "|"+Replicate("-",88 - nDifColCC)
@ li,144 - nDifColCC PSAY "|"

li++
@ li,001 PSAY "|"
@ li,054 PSAY "| Observacoes :"
@ li,144 - nDifColCC PSAY "|"

li++
@ li,001 PSAY "|"
@ li,054 PSAY "|"
@ li,144 - nDifColCC PSAY "|"

li++
@ li,001 PSAY "|"
@ li,054 PSAY "|"
@ li,144 - nDifColCC PSAY "|"

li++
@ li,001 PSAY "|        ------------------------------------"
@ li,054 PSAY "|"
@ li,144 - nDifColCC PSAY "|"

li++
@ li,001 PSAY "|"
@ li,054 PSAY "|"
@ li,144 - nDifColCC PSAY "|"

li++
@ li,001 PSAY "|"+Replicate("-",52)
@ li,054 PSAY "|"
@ li,144 - nDifColCC PSAY "|"

li++
@ li,001 PSAY "|           Responsavel pelo Pedido: "
//            012345678901234567890123456789012345678901234567890
//            0         1         2         3         4         5
@ li,054 PSAY "|"
@ li,144 - nDifColCC PSAY "|"

****************************************************
// trocar o cUsuario pelo nome completo do usuario.

aReg	:=	{}
aReg	:= PswRet()
cSenha	:= aReg[1][3]	// Senha do Usuario
cNome	:= aReg[1][4]	// Nome do Usuario

nTnome	:=	52 - Len(cNome)

nTnome	:= ROUND(nTnome/2,0)                      
//centraliza o nome do representante/vendedor.

li++
@ li,001 				PSAY "|"
@ li,003+nTnome 		PSAY AllTrim( cNome )
@ li,054 				PSAY "|"
@ li,144 - nDifColCC 	PSAY "|"

cData      := "Pindamonhangaba, " + StrZero(Day(dDataBase),2) + " de " + MesExtenso(Month(dDataBase)) + " de " + Alltrim(Str(Year(dDataBase))) // + " - " + time

li++
@ li,001 PSAY "|"
@ li,002 PSAY Replicate("-",limite)
@ li,144 - nDifColCC PSAY "|"
li++
@ li,001 PSAY "|" //|   NOTA: So aceitaremos a mercadoria se na sua Nota Fiscal constar o numero do nosso Pedido de Compras."
@ li,002 PSAY Padc(cData,128) //cData = Cidade + data de impressao por extenso.
@ li,144 - nDifColCC PSAY "|"
li++
@ li,001 PSAY "|"
@ li,002 PSAY Replicate("-",limite)
@ li,144 - nDifColCC PSAY "|"

MaFisEnd()                      

IF SCJ->CJ_CONDPAG = '000'	// SE FOR PAGAMENENTO ANTECIPADO LISTAR DADOS DO BANCO PARA DEPOSITO.

	li++
	@ li,001 PSAY "|"
	@ li,002 PSAY "***  PEDIDO COM PAGAMENTO ANTECIPADO, POR GENTILEZA EFETUAR DEPOSITO NO BANCO BRADESCO, Ag.: 0216-0 Conta Corrente: 47.899-7 ***"
	//           |12345678901234567890123456789012345678901234567890123456789012345678901234567890123456789012345678901234567890123456789012345678901|
	//           0         1         2         3         4         5         6         7         8         9        10        11        12        13
	@ li,144 - nDifColCC PSAY "|"
	
	li++
	@ li,001 PSAY "|"
	@ li,002 PSAY "                      ******** CNPJ: 54.102.488/0001-97 *** CIRCUIT EQUIPAMENTOS ESPORTIVOS LTDA ********"
	//           0|2345678901234567890123456789012345678901234567890123456789012345678901234567890123456789012345678901234567890123456789012345678901|
	//           0         1         2         3         4         5         6         7         8         9        10        11        12        13
	@ li,144 - nDifColCC PSAY "|"
		
	li++
	@ li,001 PSAY "|"
	@ li,002 PSAY Replicate("-",limite)
	@ li,144 - nDifColCC PSAY "|"
	
	li++
	@ li,001 PSAY "|"
	@ li,002 PSAY "      ***  APOS O PAGAMENTO, ENVIAR O COMPROVANTE DO DEPOSITO PARA O FAX: (12) 3648 - 3300  A/C DEPARTAMENTO FINANCEIRO  ***"
	//           0|2345678901234567890123456789012345678901234567890123456789012345678901234567890123456789012345678901234567890123456789012345678901|
	//           0         1         2         3         4         5         6         7         8         9        10        11        12        13
	@ li,144 - nDifColCC PSAY "|"

	li++
	@ li,001 PSAY "|"
	@ li,002 PSAY "           ********* CASO O DEPOSITO NAO SEJA EFETUADO EM 48HORAS, O PEDIDO SER AUTOMATICAMENTE CANCELADO ********"
	//           0|2345678901234567890123456789012345678901234567890123456789012345678901234567890123456789012345678901234567890123456789012345678901|
	//           0         1         2         3         4         5         6         7         8         9        10        11        12        13
	@ li,144 - nDifColCC PSAY "|"

	li++
	@ li,001 PSAY "|"
	@ li,002 PSAY Replicate("-",limite)
	@ li,144 - nDifColCC PSAY "|"
	
ENDIF

Return .T.

/*/


Ŀ
Funo     ImpRodape Autor  Wagner Xavier          Data           
Ĵ
Descrio  Imprime o rodape do formulario e salta para a proxima folha
Ĵ
Sintaxe    ImpRodape(Void)   			         					  
Ĵ
Parametros 					                     				      
Ĵ
 Uso       MatR110                                                    
ٱ


/*/
Static Function ImpRodape()
li++
@ li,001 PSAY "|"
@ li,002 PSAY Replicate("-",limite)
@ li,144 - nDifColCC PSAY "|"
li++
@ li,001 PSAY "|"
@ li,070 PSAY "Continua ..."
@ li,144 - nDifColCC PSAY "|"
li++
@ li,001 PSAY "|"
@ li,002 PSAY Replicate("-",limite)
@ li,144 - nDifColCC PSAY "|"
li:=0
Return .T.
/*/


Ŀ
Funo     ImpCabec  Autor  Wagner Xavier          Data           
Ĵ
Descrio  Imprime o Cabecalho do Pedido de Compra                    
Ĵ
Sintaxe    ImpCabec(Void)                                             
Ĵ
 Uso       MatR110                                                    
ٱ


/*/
Static Function ImpCabec(ncw)
Local nOrden, cCGC
Local aRelImp    := MaFisRelImp("MT100",{"SF2","SD2"})


// @ 00,000 PSAY CHR(27)+"(s4S"+CHR(27)+"(s17H"
@ 01,001 PSAY "|"
@ 01,002 PSAY Replicate("-",limite)
@ 01,144 - nDifColCC PSAY "|"
@ 02,001 PSAY "|"
@ 02,029 PSAY IIf(nOrdem>1," - continuacao"," ")	

IF __CUSERID $ GETMV("MV_CIRC001")
	@ 02,045 PSAY "| P E D I D O   D E   V E N D A S  - Representante "
ELSE
	@ 02,045 PSAY "| P E D I D O   D E   V E N D A S"
ENDIF
//             56789012345678901234567890123456789012345678901234567890
//                  5         6         7         8         9        10
@ 02,100 PSAY "|"
@ 02,110 PSAY SCJ->CJ_NUM      Picture PesqPict("SCJ","CJ_NUM")

//@ 02,107 PSAY "/"+Str(nOrdem,1)
@ 02,144 - nDifColCC PSAY "|"
@ 03,001 PSAY "|"
@ 03,003 PSAY SM0->M0_NOMECOM
@ 03,045 PSAY "|"+Replicate("-",97 - nDifColCC)
@ 03,144 - nDifColCC PSAY "|"
@ 04,001 PSAY "|"
@ 04,003 PSAY "Av. Alexandrina das Chagas Moreira, 760"
dbSelectArea("SA1")
dbSetOrder(1)
dbSeek(xFilial()+SCJ->CJ_CLIENTE+SCJ->CJ_LOJA)
@ 04,045 PSAY "|"
@ 04,047 PSAY Substr(SA1->A1_NOME,1,35)+"-"+SA1->A1_COD+"-"+SA1->A1_LOJA+" I.E.: "+" " + SA1->A1_INSCR		//" I.E.: "	
@ 04,144 - nDifColCC PSAY "|"
@ 05,001 PSAY "|"                                                                                       
@ 05,003 PSAY "CEP: "+Trans(SM0->M0_CEPENT,cCepPict)+" - "+Trim(SM0->M0_CIDENT)+" - "+SM0->M0_ESTENT
@ 05,045 PSAY "|"
@ 05,047 PSAY SA1->A1_END    		Picture PesqPict("SA1","A1_END")
@ 05,089 PSAY "-  "+Trim(SA1->A1_BAIRRO)	Picture "@!"
@ 05,144 - nDifColCC PSAY "|"
@ 06,001 PSAY "|"
@ 06,003 PSAY "TEL: "+SM0->M0_TEL		//"TEL: "
@ 06,023 PSAY "FAX: "+SM0->M0_FAX		//"FAX: "
@ 06,045 PSAY "|"
@ 06,047 PSAY Trim(SA1->A1_MUN)  Picture "@!"
@ 06,069 PSAY SA1->A1_EST    		Picture PesqPict("SA1","A1_EST")
@ 06,074 PSAY "CEP :"	//"CEP :"
@ 06,081 PSAY SA1->A1_CEP    		Picture PesqPict("SA1","A1_CEP")

dbSelectArea("SX3")
nOrden = IndexOrd()
dbSetOrder(2)
dbSeek("A1_CGC")
cCGC := Alltrim(X3TITULO())
@ 06,093 PSAY cCGC //"CGC: "
dbSetOrder(nOrden)

dbSelectArea("SA1")
@ 06,103 PSAY SA1->A1_CGC    		Picture PesqPict("SA1","A1_CGC")
@ 06,144 - nDifColCC PSAY "|"
@ 07,001 PSAY "|"
@ 07,002 PSAY " CNPJ:"+" "+ Transform(SM0->M0_CGC,cCgcPict)		//"CGC: "
@ 07,029 PSAY "IE:" + InscrEst()		//"IE:"
@ 07,045 PSAY "|"
@ 07,047 PSAY SA1->A1_CONTATO                                         
@ 07,069 PSAY "FONE: "
@ 07,075 PSAY "("+Substr(SA1->A1_DDD,1,3)+") "+ Substr(SA1->A1_TEL,1,4)+"-"+Substr(SA1->A1_TEL,5,4)
@ 07,100 PSAY "FAX: "
@ 07,106 PSAY "("+Substr(SA1->A1_DDD,1,3)+") "+ Substr(SA1->A1_FAX,1,4)+"-"+Substr(SA1->A1_FAX,5,4)
@ 07,144 - nDifColCC PSAY "|"
@ 08,001 PSAY "|"
@ 08,002 PSAY Replicate("-",limite)
@ 08,144 - nDifColCC PSAY "|"

@ 09,001 PSAY "|"
@ 09,002 PSAY "Itm|"
@ 09,009 PSAY "Codigo      "
@ 09,022 PSAY "|Descricao do Material"
@ 09,051 PSAY "|UM|  Quant."
@ 09,067 PSAY "|Valor Unitario|IPI% |  Valor Total   | Entrega  |   Valor IPI   |"
@ 10,001 PSAY "|"
@ 10,002 PSAY Replicate("-",limite)
@ 10,144 - nDifColCC PSAY "|"    

IF	SA1->A1_EST $ 'AL/AM/AP/BA/CE/ES/MA/MG/MT/PA/PI/PR/RJ/RS/SC/SP/' .AND. SA1->A1_TIPO $ 'RS' .AND. SA1->A1_GRPTRIB == '001'
	cTipoCli	:=	"S"
ELSE
	cTipoCli	:=	SA1->A1_TIPO
ENDIF

IF nOrdem == 1                                                     

	MaFisIni(	SA1->A1_COD		,;				// 1-Codigo Cliente/Fornecedor
				SA1->A1_LOJA	,;				// 2-Loja do Cliente/Fornecedor
				"C"				,;				// 3-C:Cliente , F:Fornecedor
				"N"				,;				// 4-Tipo da NF
				cTipoCli		,;				// 5-Tipo do Cliente/Fornecedor
				aRelImp			,;				// 6-Relacao de Impostos que suportados no arquivo
								,;	   			// 7-Tipo de complemento
								,;				// 8-Permite Incluir Impostos no Rodape .T./.F.
				"SB1" 			,;				// 9-Alias do Cadastro de Produtos - ("SBI" P/ Front Loja)
				"GIVIA000"		)				// 10-Nome da rotina que esta utilizando a funcao

EndIF

dbSelectArea("SCJ")
li := 11
Return .T.
